@echo off
:: ------------ Download Script ------------
:: 
SETLOCAL ENABLEDELAYEDEXPANSION
set "Version=05.22"
set "pkgType=0"
set "pkgDLType=TELIUM"
set "datafolder=HOST"
set "Wkpath=%cd%"
for /f "tokens=* delims=;" %%A in ("%Wkpath%") do (
set "Comppath=%%~dpA"
)
if "%Comppath:~-1%" == "\" (
set "Comppath=%Comppath:~0,-1%"
)
set "DEDTF=0"
set "StopLLT=0"
set "HIDEsubM=0"
set "profileName=Public Key"
set "DeviceType=TELIUM_2"
set "DDLSUBDIR=1"
set "DDLSUBDIRNAME=NA"
set "paramschk=0"
set "MEMAPIDT2=829603"
set "MEMAPIDT3=829603"

set "LLTTempPath=%ALLUSERSPROFILE%\LLTTemp"
:CHKLLTTEMPPath
if EXIST "%LLTTempPath%" (
	if EXIST "%LLTTempPath%\testlltpath.txt" (
	Del /F /S /Q "%LLTTempPath%\testlltpath.txt" >Nul
	)
	if EXIST "%LLTTempPath%\testlltpath.txt" ( 
	set "LLTTempPath=c:\temp\LLTTemp"
	) else (
	echo. Test>"%LLTTempPath%\testlltpath.txt"
		if EXIST "%LLTTempPath%\testlltpath.txt" ( 
		Del /F /S /Q "%LLTTempPath%\testlltpath.txt" >Nul
		) else (
		set "LLTTempPath=c:\temp\LLTTemp"
		)
	)
) 
if NOT EXIST "%LLTTempPath%" (mkdir "%LLTTempPath%" >Nul)
if NOT EXIST "%LLTTempPath%" ( 
set "LLTTempPath=c:\temp\LLTTemp"
mkdir "%LLTTempPath%" >Nul
)
::end of chk LLTTempPath
set "LLTTempSubP=temp"
set "Tempcfgname=%ALLUSERSPROFILE%\LLTTemp\Temp.cfg"
set "LLTtoolName=LLT.EXE"
set "LLTtoolType=0"
set "TeliumTYPE=2"
Set "LLTtempFileName=LLT.exe"

set "DelDataCatFile=SkipDataDel.txt"
set "titlechk=0"
SET "title=INGENICO PACKAGE Download Script - version: %version%"
set "Tline1=                         INGENICO PACKAGE DOWNLOAD TOOL"
set "Tline2="
set "Tline3="
set "splitL=----------------------------------------------------------------------------------"

set "resetLLT=0"
Set "FileCopied=0"
set "m=0"
set "NB=1"
set "NBT=1"
set "DPATH="
set "PNUM=NA"
set "winHigh=70"
set "dllMEMapp=0"
set "newsession=1"
set "SilentMode=0"
set "DLLoption=0"
set "PKGDoneIndicator=0"
set "outputFolder=c:\temp"
set "ExcludeComp=0"
set /a "dLLTpath=0"

:: Set color
COLOR 17
::: -- Set the window size --
MODE CON: COLS=83 LINES=%winHigh%
TITLE %title%

:: checking command line params
if NOT "X%~1" == "X" (
set "qaParam=%~1"
)
set /a "RETUSBerr=0"

if NOT "%qaParam%" == "" (
	if NOT "%qaParam%" == "/USB" (
		if NOT "%qaParam%" == "/IngPackager" (
			if NOT "%qaParam%" == "/LPKG" (
			call :Usage
			set /p T=* Press Enter Key to quit download ...
			goto :CLEAR
			) else (
			set "SilentMode=1"
			set "PKGtypeIndicator=3"
			set "TEMPPKGPATH=PKPKG"
			set "TEMPPKGDISPNM=LPKG"
			)
		) else (
		set "PKGtypeIndicator=2"
		set "TEMPPKGPATH=IngPackagerPKG"
		set "TEMPPKGDISPNM=TEM"
		set "SilentMode=1"
		)
	) else (
	set "PKGtypeIndicator=1"
	set "TEMPPKGPATH=USBPKG"
	set "TEMPPKGDISPNM=USB"
	set "SilentMode=1"
	)
) else (
set "PKGtypeIndicator=0"
set "TEMPPKGDISPNM=USB"
set "TEMPPKGPATH=USBPKG"
set "SilentMode=0"
)
set "TPATH=%PATH%"
set "LLT_TOOLS="
set "LLTPATH="

if /I "X%~2" == "X" (
set "SilentMode=0"
) else (
set "DLLoption=%~2"
)

if /I NOT "X%~3" == "X" (
set "tempoutputFolder=%~3" 
)
if "%tempoutputFolder:~0,1%" == "/" (
set "tempoutputFolder=%tempoutputFolder:~1%"
)
if exist "%tempoutputFolder%" (
set "outputFolder=%tempoutputFolder:"=%"
)

if /I NOT "X%~4" == "X" (
set "tempExcludeComp=%~4"
) else (
set "tempExcludeComp=0"
)
set "tempExcludeComp=%tempExcludeComp:"=%"
if "%tempExcludeComp:~0,1%" == "/" (
set "tempExcludeComp=%tempExcludeComp:~1%"
)
if /I NOT "%tempExcludeComp%" == "0" (
set "ExcludeComp=%tempExcludeComp%"
)

::------ Exclude files not under component folder ----------
if /I NOT "X%~5" == "X" (
set "ExcludeFiles=%~5"
) else (
set "ExcludeFiles=0"
)
set "ExcludeFiles=%ExcludeFiles:"=%"
if "%ExcludeFiles:~0,1%" == "/" (
set "ExcludeFiles=%ExcludeFiles:~1%"
)
::-------------------------

set "DLLoption=%DLLoption:/=%"
set "DLLoption=%DLLoption:\=%"

:GetLLTtempPath -- Get the LLT temp Path on this PC 
if NOT "%qaParam%" == "" (goto :skipLocalPRM)
if EXIST "%Tempcfgname%" (
	FOR /F "eol=; tokens=1,2,3,4,5,* usebackq delims=#" %%c in ("%Tempcfgname%") do (
		if "%%c" == "0" (
			if /I "%%d" == "LLTTempPath" (
			set "LLTTempPath=%%e"
			)
			if /I "%%d" == "COM" (
			set "NB=%%e"
			)
			if /I "%%d" == "DPATH" (
			set "DPATH=%%e"
				if NOT "%%f"=="" (
					if /I NOT "%%f"=="NA" (
						if /I "%%g"=="Default LLT PATH and Name on this PC" (
						set "LLTtoolName=%%f"
						)
					)
				)
			)
::compatible with old tempcfg format
			if /I "%%d" == "LLTtoolName" (
			set "LLTtoolName=%%e"
			)
			if /I "%%d" == "LLTtoolType" (
			set "LLTtoolType=%%e"
			)
		)
	)
) 

:skipLocalPRM
:: prepare environment
:: -----------------------------------------------------
:: Note: 
::      Factory.cfg -- Factory Download Package default configuration
::      Custdll.cfg -- Customer Download Package default configuration
::      Temp.cfg -- User's COM and LLT path configuration
::      
:: -----------------------------------------------------

if EXIST "%Wkpath%\Factory.cfg" (
set "Fname=%Wkpath%\Factory.cfg"
set "opt=Factory Download"
set "HIDEsubM=1"
)
if EXIST "%Wkpath%\Custdll.cfg" (
set "Fname=%Wkpath%\Custdll.cfg"
set "opt=Customer Download"
)

if "%Fname%" == "" ( set "Fname=emptycfgfile" )
::to be reviewed 
if NOT EXIST "%Fname%" (
cls
echo.
echo.%date%-%time%: Failed to Start - MISSING CONFIGURATION FILE >>"%ALLUSERSPROFILE%\LLTTemp\log\download.log"
echo.###########################################################
echo.#                                                         #
echo.#  MISSING CONFIGURATION FILE, DOWNLOAD FAILED TO START!  #
echo.#                                                         #
echo.###########################################################
echo.
set "Result=Missing Configuration File."
set /P option= # Press any key to quit ...
goto :END
)
goto :DPNUM

:DPNUM -- Get Part Number from configuration file if provided 
FOR /F "eol=; tokens=1,2,3,4,5,* usebackq delims=#" %%c in ("%Fname%") do (
	if %%c EQU 0 (
		if /I "%%d" == "PNUM" (
		set "PNUM=%%e"
		)
		if /I "%%d" == "DEDTF" (
		set "DEDTF=%%e"
		call set "DelDataCatFile=%%f"
		)
		if NOT EXIST "%Tempcfgname%" (
			if /I "%%d" == "COM" (
			set "NB=%%e"
			)
			if /I "%%d" == "DPATH" (
			set "DPATH=%%e"
				if /I NOT "X%%f"=="X" (
					if /I NOT "%%f"=="NA" ( 
					set "LLTtoolName=%%f"
					)
				)
			)
			::compatible with old cfg format
			if /I "%%d" == "LLTtoolName" (
			set "LLTtoolName=%%e"
			)
		)

		if /I "%%d" == "dllMEMapp" (
		set "dllMEMapp=%%e"
			if /I NOT "X%%f" == "X" (
				if /I NOT "X%%f" == "XNA" (
				set "MEMAPIDT2=%%f"
				)
			)
			if /I NOT "X%%g" == "X" (
				if /I NOT "X%%g" == "XNA" (
				set "MEMAPIDT3=%%g"
				)
			)
		)
		if "%%d" == "DDLSUBDIR" (
			if /I NOT "X%%e" == "X" (
			set "DDLSUBDIR=%%e"
			)
		)
		if "%%d" == "DDLSUBDIRNAME" (
			if /I NOT "X%%e" == "X" (
			set "DDLSUBDIRNAMET2=%%e"
			)
			if /I NOT "X%%f" == "X" (
			set "DDLSUBDIRNAMET3=%%f"
			)
		)
	)
)

::------backward compatibility with old cfg-------
if /I "X%MEMAPIDT2:~0, 1%" == "X;" (
set "MEMAPIDT2=829603"
)
if /I "X%MEMAPIDT3:~0, 1%" == "X;" (
set "MEMAPIDT3=829603"
)
::-------------------- end ----------------------
if NOT "%DDLSUBDIR%" == "0" ( 
	if NOT "%DDLSUBDIR%" == "1" ( 
		if NOT "%DDLSUBDIR%" == "2" ( 
		set "DDLSUBDIR=1" 
		)
	)
)

if /I "X%DDLSUBDIRNAMET2:~0, 1%" == "X;" ( set "DDLSUBDIRNAMET2=NA" )
if /I "X%DDLSUBDIRNAMET2%" == "X" ( set "DDLSUBDIRNAMET2=NA" )
if /I "X%DDLSUBDIRNAMET3:~0, 1%" == "X;" ( set "DDLSUBDIRNAMET3=NA" )
if /I "X%DDLSUBDIRNAMET3%" == "X" ( set "DDLSUBDIRNAMET3=NA" )

goto :PNSELCHK

:PNSELCHK
tasklist /v /fi "imagename eq %LLTtoolName%" 2>nul |findstr "LLT" >nul && set "checksession=Y"||Set "checksession=N"

if "%checksession%" == "Y" (
taskkill /IM %LLTtoolName% /F>nul
if %errorlevel% == 0 (set "StopLLT=1")
)

set "PNTempPath=%cd%"

for /f "tokens=* delims=;" %%A in ("%PNTempPath%") do (
set "PNTempPath=%%~dpA"
)

if "%PNTempPath:~-1%" == "\" (
set "PNTempPath=%pathprefix%%PNTempPath:~0,-1%"
) ELSE (
set "PNTempPath=%pathprefix%%PNTempPath:~0%"
)
for /f "tokens=* delims=;" %%A in ("%PNTempPath%") do (
set "PNTempPath=%%~dpA"
set "DeviceType=%%~nA"
)

for /f "tokens=* delims=;" %%A in ('dir /AD /B "%Comppath%\*"') do (
	if /I NOT "%%~nA" == "Scripts" (
		if /I NOT "%%~nA" == "Script" (
		set "pkgDLType=%%~nA"
		)
	)
)

if EXIST ".\custdll.cfg" (
	if NOT EXIST "%Comppath%\%pkgDLType%" (
		for /f "tokens=* delims=;" %%A in ("..\..\..\Factory Download\%DeviceType%") do (
		set "Comppath=%%~dpnA"
		)
		for /f "tokens=* delims=;" %%A in ('dir /AD /B "..\..\..\Factory Download\%DeviceType%\*"') do (
			if /I NOT "%%~nA" == "Scripts" (
				if /I NOT "%%~nA" == "Script" (
				set "pkgDLType=%%~nA"
				)
			)
		)
	)
)

if /I "%pkgDLType%" == "TELIUM" (
set "TeliumTYPE=2"
	if /I "%DDLSUBDIRNAMET2%" == "NA" (
	set "datafolder=HOST"
	) else (
	set "datafolder=%DDLSUBDIRNAMET2%"
	)
) ELSE (
	if /I "%pkgDLType%" == "TELIUM3" (
	set "TeliumTYPE=3"
		if /I "%DDLSUBDIRNAMET3%" == "NA" (
		set "datafolder=import"
		) else (
		set "datafolder=%DDLSUBDIRNAMET3%"
		)
	) ELSE (
	set "TeliumTYPE=3"
		if /I "%DDLSUBDIRNAMET3%" == "NA" (
		set "datafolder=import"
		) else (
		set "datafolder=%DDLSUBDIRNAMET3%"
		)
	)
)

if "%PNTempPath:~-1%" == "\" (
set "PNTempPath=%pathprefix%%PNTempPath:~0,-1%"
) ELSE (
set "PNTempPath=%pathprefix%%PNTempPath:~0%"
)

for /f "tokens=* delims=;" %%A in ("%PNTempPath%") do (
set "PNTempPath=%%~dpA"
)

if "%PNTempPath:~-1%" == "\" (
set "PNTempPath=%pathprefix%%PNTempPath:~0,-1%"
) ELSE (
set "PNTempPath=%pathprefix%%PNTempPath:~0%"
)

for /f "tokens=* delims=;" %%A in ("%PNTempPath%") do (
	if /I NOT "%%~nxA" == "%PNUM%" (
		if /I NOT "X%PNUM%" == "XNA" (
		set "Tline2=============  Warning: Config file does not match the current package  ==========="
		)
	)
	set "PNUM=%%~nxA"
)

If "%pkgDLType%" == "" (
set "pkgDLType=TELIUM"
)

if "%pkgDLType:~9%" == "" (
set "titlechk=0"
) else (
	if "%pkgDLType:~18%" == "" (
	set "titlechk=1"
	) else (
	set "titlechk=2"
	)
)

if "%PNUM%" NEQ "" (
    if EXIST "..\..\..\..\%PNUM%" (
    	if "%titlechk%" == "0" (
    	set "Tline1=                    INGENICO %DeviceType% PACKAGE: %PNUM%"
    	) else (
    		if "%titlechk%" == "1" (
    		set "Tline1=                INGENICO %DeviceType% PACKAGE: %PNUM%"
    		) else (
    		set "Tline1=           INGENICO %DeviceType% PACKAGE: %PNUM%"
    		)
    	)
    ) ELSE (
    goto :InstLocal
    )
)

if NOT "%PNUM:~5,5%" == "" (
set "LLTTempSubP=%PNUM:~0,15%"
set "PKGCore=%PNUM:~5,5%"
) ELSE (
set "LLTTempSubP=temp"
set "PKGCore=Unknown"
)
set "LLTTempSubP=%LLTTempSubP:-=%"

if "%LLTTempSubP%" == "" (goto :InstLocal)
goto :PRECLEAN

:PRECLEAN
set "result_file=%LLTTempPath%\%LLTTempSubP%\jLLTresult_file.txt"
::-------checking and prepare temp folder -----
if EXIST "%LLTTempPath%\LocalLLTPath.txt" (Del /F /S /Q "%LLTTempPath%\LocalLLTPath.txt" >Nul)
if EXIST "%LLTTempPath%\%LLTTempSubP%" (Del /F /S /Q "%LLTTempPath%\%LLTTempSubP%" >Nul)
if EXIST "%LLTTempPath%\%LLTTempSubP%" (RMDIR /S /Q "%LLTTempPath%\%LLTTempSubP%" >Nul)
set "FileNum=0"

>nul 2>nul dir /a-d "%LLTTempPath%\%LLTTempSubP%\TEMPPKG\*.*" && (set "FileNum=1") || (set "FileNum=0")

if "%FileNum%" == "1" (goto :InstLocal)

if NOT EXIST "%LLTTempPath%\%LLTTempSubP%" (mkdir "%LLTTempPath%\%LLTTempSubP%" >Nul)
if NOT EXIST "%LLTTempPath%\%LLTTempSubP%" (goto :InstLocal)

if NOT EXIST "%LLTTempPath%\%LLTTempSubP%\TEMPPKG" (mkdir "%LLTTempPath%\%LLTTempSubP%\TEMPPKG" >Nul)
if NOT EXIST "%ALLUSERSPROFILE%\LLTTemp\log" (mkdir "%ALLUSERSPROFILE%\LLTTemp\log" >Nul)
::-------backup download.log -----
for /f "tokens=2-8 delims=/:. " %%A in ("%date%:%time: =0%") do (
set "Extname=%%C%%A%%B%%D%%E%%F%%G"
)
set "Fsize=0"
if EXIST "%ALLUSERSPROFILE%\LLTTemp\log\download.log" (
	for %%A in ("%ALLUSERSPROFILE%\LLTTemp\log\download.log") do (
	set "Fsize=%%~zA"
	)
)

if %Fsize% GEQ 100000 (
RENAME "%ALLUSERSPROFILE%\LLTTemp\log\download.log" "download.log.%Extname%"
echo.%date%-%time%: Download.log backup file - "download.log.%Extname%" >>"%ALLUSERSPROFILE%\LLTTemp\log\download.log"
)

echo. >>"%ALLUSERSPROFILE%\LLTTemp\log\download.log"
echo.%date%-%time%: ---------- Script is started by %USERNAME% ---------- >>"%ALLUSERSPROFILE%\LLTTemp\log\download.log"

if NOT "%DPATH%" == "" (
set "LLTPATH=%DPATH%"
) 

goto :LLTSelCHK

::------------------ Start Downloadopt Function --------------------

:Menu -- Get User download option and then start download.
set "tempprofStatus=0"
set "reDllmenu=0"
set "reDllmenutemp0=0"
set "reDllmenutemp1=0"
set "reDllmenutemp3=0"
echo. >>"%ALLUSERSPROFILE%\LLTTemp\log\download.log"
echo.          *********          *********          *********>>"%ALLUSERSPROFILE%\LLTTemp\log\download.log"
echo. >>"%ALLUSERSPROFILE%\LLTTemp\log\download.log"
set "m=0"
set "doneUSBcp=0"
set "noUSBkey=0"

:RESMenu
if "%SilentMode%" == "1" ( 
	if NOT EXIST "%outputFolder%\%LLTTempSubP%" (mkdir "%outputFolder%\%LLTTempSubP%" >Nul)
set "reDllmenu=3"
goto :NoGUIMode 
)
if "%PKGtypeIndicator%" == "0" (
set "qaParam=/USB"
)
set "StopLLT=0"
tasklist /v /fi "imagename eq %LLTtoolName%" 2>nul |findstr "llt" >nul && set "checksession=Y"||Set "checksession=N"

if "%checksession%" == "Y" (
taskkill /IM %LLTtoolName% /F>nul
if %errorlevel% == 0 (set "StopLLT=1")
)

set "resetLLT=0"
set "DisaMemDLL=0"
set "perln="
FOR /F "tokens=1,2,3 usebackq delims=#" %%s in ("%LLTTempPath%\%LLTTempSubP%\recomPort.txt") do (
	set "PortCHK=%%t"
)

if "%PortCHK%" == "i" ( set "PortCHK=I" )
set "paramschk=0"
cls
if ."%opt%". == ."Factory Download". (
echo.
echo.                    *** Factory Download Package is selected ***
)
echo.
echo.%Tline1% 
echo.%Tline2%
echo.                           %opt% Options 
echo.--------------------------+---------------------------+---------------------------
echo.
set /a "itemNum=0"
FOR /F "eol=; tokens=1,2,3,4,5,6,7 usebackq delims=#" %%i in ("%Fname%") do (
	if %%i NEQ 0 (
		if EXIST "%LLTTempPath%\%LLTTempSubP%\TEMPPKG\%%j" (
		echo.        %%i: %%k
		set /a "itemNum=%%i"
		) ELSE (
		COLOR 47
		echo.        -: %%k ***MISSING CAT FILE***
		)
	)
)
set /a "itemNum=%itemNum%+1"
if ."%opt%". == ."Factory Download". (
	if "%PKGtypeIndicator%" == "0" (
		if "%LLTtoolType%" == "1" (
			if /I "%TeliumTYPE%" == "3" (			
			echo.        %itemNum%: Clean Terminal
			)
		)
	)
)
echo.
echo.%splitL%
echo.

if "%pkgType%" == "1" (
	echo.      *************************************************************
	echo.        For brand new terminal, load OS first to setup profile    
	echo.      *************************************************************
	echo.
)
if "%pkgType%" == "2" (
	if NOT "%MultiProfile%" EQU "1" (
	echo.      *************************************************************
	echo.        Profile^: Key will NOT be loaded - %MultiProfile% Key File^(s^) in Package  
	echo.      *************************************************************
	echo.
	)
)
if "%pkgType%" == "3" (
	if NOT "%MultiProfile%" EQU "1" (
	echo.      *************************************************************
	echo.        Profile^: ESSP will NOT be loaded - %MultiProfile% ESSP File^(s^) in Package  
	echo.      *************************************************************
	echo.
	)
)
if "%pkgType%" == "0" (
COLOR 47
	echo.      *************************************************************
	echo.        Unknown package type, make sure it is correct PKG 
	echo.      *************************************************************
	echo.
)
if "%HIDEsubM%" == "0" (
	if "%PKGtypeIndicator%" == "0" (
	echo.             C = Change COM port
	echo.             S = Switch to Create %TEMPPKGDISPNM% dll PKG
		if EXIST "%LLTTempPath%\%LLTTempSubP%\TEMPPKG\%DelDataCatFile%" (
		echo.             D = Delete data file from %datafolder% drive
		)
	echo.             L = Change LLT download tool
	) ELSE (
		if "%PKGtypeIndicator%" == "1" (
		echo.             S = Switch to LPKG package
			if "%reDllmenu%" == "2" (
				if EXIST "%LLTTempPath%\%LLTTempSubP%\%TEMPPKGPATH%\%pkgDLType%" (
				echo.             R = Remove the %TEMPPKGDISPNM% temporary package
				echo.
				echo.             O = Open %TEMPPKGDISPNM% temporary package
				echo.             T = Transfer %TEMPPKGDISPNM% Temp PKG to %TEMPPKGDISPNM% Flash Drive 
				)
			)
		) else (
			if "%PKGtypeIndicator%" == "3" (
				echo.             S = Switch to LLT package download
				if "%reDllmenu%" == "2" (
					if EXIST "%LLTTempPath%\%LLTTempSubP%\%TEMPPKGPATH%\%pkgDLType%" (
					echo.             R = Remove the %TEMPPKGDISPNM% temporary package
					echo.
					echo.             O = Open %TEMPPKGDISPNM% temporary package
					)
				)
			)
		) 
	)
	echo.
	echo.                 H = Hide extra features
) ELSE (
echo.                 M = More features
)
echo.                 X = Exit
echo.
if "%reDllmenu%" == "1" (
call :REDLLNOW
) 
if "%PKGtypeIndicator%" == "0" (
echo.%Tline3%
	if "%StopLLT%" == "1" (echo. LLT session cleared)
echo. Download Tool: %LLTtoolName% 
echo. PATH: "%LLTPATH%"
echo.%Tline3%
	if 	"%COMSTATUS%" == "" (
	echo. LLT DOWNLOAD MODE^: Please select download COM Port using option "C".
	) ELSE (
	echo. LLT DOWNLOAD MODE^: COM%NB% ^(%COMSTATUS%^)
	)
echo.%splitL%
echo.
) ELSE ( 
	if "%PKGtypeIndicator%" == "1" (
	echo.%Tline3%
	call :REDLLUSB
	echo.%Tline3%
	echo. %TEMPPKGDISPNM% Download MODE^: %TEMPPKGDISPNM% Flash Drive formated with^: FAT16 or FAT32.
	echo.%splitL%
	echo.
	) else (
		if "%PKGtypeIndicator%" == "3" (
		echo.%Tline3%
		call :REDLLUSB
		echo.%Tline3%
		echo. %TEMPPKGDISPNM% Packaging MODE.
		echo.%splitL%
		echo.
		)
	)
)

if "%reDllmenu%" == "2" (
	if "%PKGtypeIndicator%" == "1" (
		if "%noUSBkey%" == "1" (             
		echo.            * Could not find the %TEMPPKGDISPNM% Flash Drive drive on your PC ... *
		echo.
		) ELSE (
			if "%noUSBkey%" == "2" (             
			echo.     * Error occured, please manully Transfer %TEMPPKGDISPNM% temp PKG to %TEMPPKGDISPNM% drive ... *
			echo.
			) ELSE (
				if "%noUSBkey%" == "3" (           
				echo.           * Transfer %TEMPPKGDISPNM% temp package has been Cancelled by user ... *
				echo. 
				)
			)
		)
		if EXIST "%LLTTempPath%\%LLTTempSubP%\%TEMPPKGPATH%\%pkgDLType%\" (
			if /I "%option%"== "O" ( 
			set "m=0"
			start explorer "%LLTTempPath%\%LLTTempSubP%\%TEMPPKGPATH%\"
			) ELSE (
				if /I "%option%" == "T" ( 
				set "noUSBkey=0"
				set "m=0"
				echo.
				echo.    Please wait ...
				call :usbdrlist
				set "numb=0"
				call :copyUSBkey
				)
			)
		)
	) else (
		if "%PKGtypeIndicator%" == "3" (
			if EXIST "%LLTTempPath%\%LLTTempSubP%\%TEMPPKGPATH%\%pkgDLType%\" (
				if /I "%option%"== "O" ( 
				set "m=0"
				start explorer "%LLTTempPath%\%LLTTempSubP%\%TEMPPKGPATH%\"
				) 
			)
		)	
	)
)
if %m% == 1 (
	if NOT "%PKGtypeIndicator%" == "0" (
	echo.                   * Invalid option selected *
	) ELSE (
		if "%COMSTATUS%" == "" (
		echo.          * Invalid option selected^: No COM Port defined. *
		) ELSE (
		echo.                   * Invalid option selected *
		)
	)
	echo.
)

set "option="
echo.* Default option [1] will be selected if OK is pressed.
if "%PKGtypeIndicator%" == "0" (
	set /p option=". Please enter your choice to start download: "
) else (
set /p option=". Please enter your choice to Create %TEMPPKGDISPNM% package: "
)
echo.
:NoGUIMode
if "%SilentMode%" == "1" ( 
	if "%PKGDoneIndicator%" == "0" (
	set "option=%DLLoption%" 
	) else (
	set "option=X"
	)
set "PKGDoneIndicator=1"
)

if "%option%" == "" (
set "option=1"
)

if /I "%option%" == "X" ( 
	if "%reDllmenu%" == "1" (
	goto :CLEAR
	) ELSE (
		if "%reDllmenu%" == "3" (
		goto :CLEAR
		) else (
		goto :Exit
		)
	)
)
if "%PKGtypeIndicator%" == "1" ( 
	if EXIST "%LLTTempPath%\%LLTTempSubP%\%TEMPPKGPATH%\%pkgDLType%\" (
		if /I "%option%" == "T" ( 
		set "noUSBkey=0"
		)
	)
)
if /I "%option%" == "M" ( 
set "HIDEsubM=0"
goto :RESMenu
)
if /I "%option%" == "H" ( 
set "HIDEsubM=1"
goto :RESMenu
)

if /I "%option%" == "R" ( 
set /a RETUSBerr=0
	if EXIST "%LLTTempPath%\%LLTTempSubP%\USBpkg_Failed.txt" (Del /S /Q "%LLTTempPath%\%LLTTempSubP%\USBpkg_Failed.txt" >nul)
set "tempprofStatus=0"
	if EXIST "%LLTTempPath%\%LLTTempSubP%\%TEMPPKGPATH%\%pkgDLType%\" (
	RMDIR /S /Q "%LLTTempPath%\%LLTTempSubP%\%TEMPPKGPATH%\%pkgDLType%\" >Nul
	set "m=0"
	) ELSE (
	set "m=1"
	)
set "doneUSBcp=0"
goto :RESMenu
)

if /I "%option%" == "L" ( 
	if "%PKGtypeIndicator%" == "0" ( 
	set "m=0"
	set "resetLLT=1"
	::PartialFindjLLT
	set "PartialChk=1"
	goto :LLTSel
	) 
)

if /I "%option%" == "S" ( 
	if "%PKGtypeIndicator%" == "0" ( 
	set "TEMPPKGDISPNM=USB"
	set "TEMPPKGPATH=USBPKG"
	set "PKGtypeIndicator=1"
	set "qaParam=/USB"
	set "reDllmenutemp0=%reDllmenu%"
	set "reDllmenu=%reDllmenutemp1%"
	set "m=0"
	) else (
		if "%PKGtypeIndicator%" == "1" ( 
		set "TEMPPKGDISPNM=LPKG"
		set "TEMPPKGPATH=PKPKG"
		set "PKGtypeIndicator=3"
		set "qaParam=/LPKG"
		set "reDllmenutemp1=%reDllmenu%"
		set "reDllmenu=%reDllmenutemp3%"
		set "m=0"	
		) else (
			if "%PKGtypeIndicator%" == "3" ( 
			set "TEMPPKGDISPNM=USB"
			set "TEMPPKGPATH=USBPKG"
			set "PKGtypeIndicator=0"
			set "qaParam=/USB"
			set "reDllmenutemp3=%reDllmenu%"
			set "reDllmenu=%reDllmenutemp0%"
			set "m=0"
			)
		)
	)
goto :RESMenu
)

if /I "%option%" == "D" (
	if EXIST "%LLTTempPath%\%LLTTempSubP%\TEMPPKG\%DelDataCatFile%" (
	set "deleteDataFList=%LLTTempPath%\%LLTTempSubP%\TEMPPKG\%DelDataCatFile%"
	call :DelDataGO
	set "m=0"
	goto :RESMenu
	)
)

if "%PKGtypeIndicator%" == "0" (
	if /I "%option%" == "C" (
	set "NBT=1"
	set "m=0"
	set "chkLines="
	call :ReENTCOM
		FOR /F "tokens=1,2,3 usebackq delims=#" %%s in ("%LLTTempPath%\%LLTTempSubP%\recomPort.txt") do (
			if "%%t" == "X" ( goto :Exit )
			if "%%t" == "x" ( goto :Exit )
		)
	set "PortCHK="
	goto :RESMenu
	)
)
 
If "%itemNum%" == "%option%" (
	if "%PKGtypeIndicator%" == "0" (
	set "perlk=Clean Terminal"
	call :CleanTerminal
	) 
goto :RESMenu
)

if "%COMSTATUS%" == "" (
	if "%PKGtypeIndicator%" == "0" (
		set "m=1"
		goto :RESMenu		
	) ELSE (
		FOR /F "eol=; tokens=1,2,3,4,5,6,7 usebackq delims=#" %%i in ("%Fname%") do (
			if %%i NEQ 0 (
				if EXIST "%LLTTempPath%\%LLTTempSubP%\TEMPPKG\%%j" (
					if "%%i" == "%option%" (
					echo.%date%-%time%: Download option is selected: %%i. %%k, CFG file-%%n >>"%ALLUSERSPROFILE%\LLTTemp\log\download.log"
					echo.%date%-%time%: Files Download started >>"%ALLUSERSPROFILE%\LLTTemp\log\download.log"
					echo.
					set "perlk=%%k"
					set "DisaMemDLL=%%o"
						if "%%o" == ";" (set "DisaMemDLL=NA")
						if NOT "%%m" == "" (
							if NOT "%%m" == "NA" (
								if NOT "%%n" == "" ( 
									if NOT "%%n" == "NA" ( 
									set "perln=%%n"
									copy /Y "%LLTTempPath%\%LLTTempSubP%\TEMPPKG\%%n" "%LLTTempPath%\%LLTTempSubP%\TEMPPKG\%%m" >Nul
									) ELSE (
									set "perln="
									)
								)
							)
						)
					set "perlj=%%j"
					set "perlc=%%j"
					set "profStatus=0"
						if "%MultiProfile%" == "1" (
							if "%%l" == "D1" (
									if EXIST "%LLTTempPath%\%LLTTempSubP%\TEMPPKG\%%~nj_withProfile%%~xj" (Del /S /Q "%LLTTempPath%\%LLTTempSubP%\TEMPPKG\%%~nj_withProfile%%~xj" >Nul)
							type "%LLTTempPath%\%LLTTempSubP%\TEMPPKG\Load_profile.Mxx" > "%LLTTempPath%\%LLTTempSubP%\TEMPPKG\%%~nj_withProfile%%~xj"
							echo.;>>"%LLTTempPath%\%LLTTempSubP%\TEMPPKG\%%~nj_withProfile%%~xj"
							type "%LLTTempPath%\%LLTTempSubP%\TEMPPKG\%%j" >>"%LLTTempPath%\%LLTTempSubP%\TEMPPKG\%%~nj_withProfile%%~xj"
							set "perlj=%%~nj_withProfile%%~xj"
							set "profStatus=1"
							)
						)			
					call :loadSelected
						if "%PKGtypeIndicator%" == "0" (
						echo.%date%-%time%: LLT Connection closed: %%k >>"%ALLUSERSPROFILE%\LLTTemp\log\download.log"
						set "m=0"
						goto :Status
						) ELSE (			
						echo.%date%-%time%: %TEMPPKGDISPNM% temp PKG generated: %%k >>"%ALLUSERSPROFILE%\LLTTemp\log\download.log"
						set "m=0"
						set "doneUSBcp=0"
						goto :RESMenu
						)
					)
				) 
			)
		)		
	)
) ELSE (
	FOR /F "eol=; tokens=1,2,3,4,5,6,7 usebackq delims=#" %%i in ("%Fname%") do (
		if %%i NEQ 0 (
			if EXIST "%LLTTempPath%\%LLTTempSubP%\TEMPPKG\%%j" (
				if %%i == %option% (
				echo.%date%-%time%: Download option is selected: %%i. %%k, CFG file-%%n >>"%ALLUSERSPROFILE%\LLTTemp\log\download.log"
				echo.%date%-%time%: Files Download started >>"%ALLUSERSPROFILE%\LLTTemp\log\download.log"
				echo.
				set "perlk=%%k"
				set "DisaMemDLL=%%o"
					if "%%o" == ";" (set "DisaMemDLL=NA")
					if NOT "%%m" == "" (
						if NOT "%%m" == "NA" (
							if NOT "%%n" == "" ( 
								if NOT "%%n" == "NA" ( 
								set "perln=%%n"
								copy /Y "%LLTTempPath%\%LLTTempSubP%\TEMPPKG\%%n" "%LLTTempPath%\%LLTTempSubP%\TEMPPKG\%%m" >Nul
								) ELSE (
								set "perln="
								)
							)
						)
					)	
					
				set "perlj=%%j"
				set "perlc=%%j"
				set "profStatus=0"
						if "%MultiProfile%" == "1" (
							if "%%l" == "D1" (
									if EXIST "%LLTTempPath%\%LLTTempSubP%\TEMPPKG\%%~nj_withProfile%%~xj" (Del /S /Q "%LLTTempPath%\%LLTTempSubP%\TEMPPKG\%%~nj_withProfile%%~xj" >Nul)
							type "%LLTTempPath%\%LLTTempSubP%\TEMPPKG\Load_profile.Mxx" > "%LLTTempPath%\%LLTTempSubP%\TEMPPKG\%%~nj_withProfile%%~xj"
							echo.;>>"%LLTTempPath%\%LLTTempSubP%\TEMPPKG\%%~nj_withProfile%%~xj"
							type "%LLTTempPath%\%LLTTempSubP%\TEMPPKG\%%j" >>"%LLTTempPath%\%LLTTempSubP%\TEMPPKG\%%~nj_withProfile%%~xj"
							set "perlj=%%~nj_withProfile%%~xj"
							set "profStatus=1"
							)
						)				
				call :loadSelected
					if "%PKGtypeIndicator%" == "0" (
					echo.%date%-%time%: LLT Connection closed:%%k >>"%ALLUSERSPROFILE%\LLTTemp\log\download.log"
					set "m=0"
					goto :Status
					) ELSE (					
					echo.%date%-%time%: %TEMPPKGDISPNM% temp PKG generated:%%k >>"%ALLUSERSPROFILE%\LLTTemp\log\download.log"
					set "m=0"
					goto :RESMenu
					)
				)
			) 
		)
	)
)
set "m=1"
goto :RESMenu
::------------------ End Downloadopt Function ------------------------
::------------------Erase All ----------------------------------------
:CleanTerminal
COLOR 17

set "profStatus=0"
echo.^<^?xml version ^= ^"1.0^" encoding ^= ^"ISO^-8859^-1^"^?^>>"%LLTTempPath%\%LLTTempSubP%\TEMPPKG\jLLTdownload.xml"
echo.^<project>>"%LLTTempPath%\%LLTTempSubP%\TEMPPKG\jLLTdownload.xml"
echo.    name ^= ^"Loader^">>"%LLTTempPath%\%LLTTempSubP%\TEMPPKG\jLLTdownload.xml"
echo.    basedir ^= ^".^">>"%LLTTempPath%\%LLTTempSubP%\TEMPPKG\jLLTdownload.xml"
echo.    default ^= ^"CLEANTERMINAL^"^>>>"%LLTTempPath%\%LLTTempSubP%\TEMPPKG\jLLTdownload.xml"
echo.    ^<^^!^-^-For Telium TETRA terminals ^-^-^>>>"%LLTTempPath%\%LLTTempSubP%\TEMPPKG\jLLTdownload.xml"
echo.    ^<target name ^= ^"CLEANTERMINAL^"^>>>"%LLTTempPath%\%LLTTempSubP%\TEMPPKG\jLLTdownload.xml"
:: added for log download error
echo.        ^<jllt.commandLineTask>>"%LLTTempPath%\%LLTTempSubP%\TEMPPKG\jLLTdownload.xml"
echo.            action ^= ^"enable^">>"%LLTTempPath%\%LLTTempSubP%\TEMPPKG\jLLTdownload.xml"
echo.            option ^= ^"result file^">>"%LLTTempPath%\%LLTTempSubP%\TEMPPKG\jLLTdownload.xml"
echo.            target ^= ^"%result_file%^"^/^>>>"%LLTTempPath%\%LLTTempSubP%\TEMPPKG\jLLTdownload.xml"
::----------------
echo.        ^<jllt.commandLineTask>>"%LLTTempPath%\%LLTTempSubP%\TEMPPKG\jLLTdownload.xml"
echo.            action ^= ^"connect^">>"%LLTTempPath%\%LLTTempSubP%\TEMPPKG\jLLTdownload.xml"
echo.            device ^= ^"COM%NB%^"^/^>>>"%LLTTempPath%\%LLTTempSubP%\TEMPPKG\jLLTdownload.xml"
echo.        ^<jllt.commandLineTask>>"%LLTTempPath%\%LLTTempSubP%\TEMPPKG\jLLTdownload.xml"
echo.            action ^= ^"terminals^">>"%LLTTempPath%\%LLTTempSubP%\TEMPPKG\jLLTdownload.xml"
echo.            target ^= ^"C^:^\^\Terminals.txt^"^/^>>>"%LLTTempPath%\%LLTTempSubP%\TEMPPKG\jLLTdownload.xml"

echo.        ^<jllt.commandLineTask>>"%LLTTempPath%\%LLTTempSubP%\TEMPPKG\jLLTdownload.xml"
echo.            action ^= ^"clean^">>"%LLTTempPath%\%LLTTempSubP%\TEMPPKG\jLLTdownload.xml"
echo.			 option = "uninstall packages"^/^>>>"%LLTTempPath%\%LLTTempSubP%\TEMPPKG\jLLTdownload.xml"
echo.        ^<jllt.commandLineTask action ^= ^"disconnect^"^/^>>>"%LLTTempPath%\%LLTTempSubP%\TEMPPKG\jLLTdownload.xml"
echo.    ^<^/target^>>>"%LLTTempPath%\%LLTTempSubP%\TEMPPKG\jLLTdownload.xml"
echo.^<^/project^>>>"%LLTTempPath%\%LLTTempSubP%\TEMPPKG\jLLTdownload.xml"
::--------------------------------------
cls
if ."%opt%". == ."Factory Download". (
echo.
echo.                  *** Factory Download Package is selected ***
)
Echo.
Echo.%Tline1% 
echo.%Tline2%
echo.                %opt% - Clean Tetra Terminal - Erase All
echo.---------------------+----------------------------------+-------------------------
echo.
echo.              ****************************************************
echo.              * This will erase all applications in the terminal *
echo.              ****************************************************
echo.
echo.          ------------------------------------------------------------
echo.%Tline3%
echo.    %LLTtoolName% PATH: "%LLTPATH%"
echo.    COM PORT: COM%NB% ^(%COMSTATUS%^)
echo.%date%-%time%: Download utility %LLT% is selected >>"%ALLUSERSPROFILE%\LLTTemp\log\download.log"
echo.%date%-%time%: COM %NB% is selected >>"%ALLUSERSPROFILE%\LLTTemp\log\download.log"
echo.%date%-%time%: Attempting to erase all applications in the terminal >>"%ALLUSERSPROFILE%\LLTTemp\log\download.log"
echo.%splitL%
echo.
echo.* Please launch LLT on the terminal
set /p T=  When "LLT" displayed, press Enter Key to continue ...
echo.
echo.* Attempt to erase all applications in the terminal ...
::--------------------------------------
echo Calling the "CLEANTERMINAL" ANT target...

cd /d "%LLTTempPath%\%LLTTempSubP%\TEMPPKG"

set "VERBOSE="
set "VERBOSE=-Dverbose"
set "LOG_FILE=%LLTTempPath%\workspace\.metadata\.log"
set "DATETIME=%DATE:/=%-%TIME::=%"
set "DATETIME=%DATETIME:,=%"
if exist "%LOG_FILE%" (
	move "%LOG_FILE%" "%LLTTempPath%\workspace\.metadata\%DATETIME%.log"
	rem.>"%LOG_FILE%"
)

if exist "%result_file%" (Del /S /Q "%result_file%">Nul)
call "%LLT%" --launcher.suppressErrors -nosplash -application org.eclipse.ant.core.antRunner %VERBOSE% -D%NB% -buildfile "jLLTdownload.xml" CLEANTERMINAL

set "Retcode=%ERRORLEVEL%"
if EXIST "%result_file%" (
	for /f "tokens=1,* delims=	 " %%G IN ('type "%result_file%"') DO (
	set "errcode=%%G"
	set "errDescription=%%H"
	)
)

if NOT "%Retcode%" == "0" (
echo.-%Retcode%>"%LLTTempPath%\%LLTTempSubP%\TEMPPKG\Batchlog.txt"
) else (
echo.%Retcode%>"%LLTTempPath%\%LLTTempSubP%\TEMPPKG\Batchlog.txt"
)
set "newsession=0"
goto :Status

:usbdrlist
if EXIST "%LLTTempPath%\%LLTTempSubP%\USBdrletter.txt" (Del /S /Q "%LLTTempPath%\%LLTTempSubP%\USBdrletter.txt">Nul)
set "drlist="
set "drtype="
set "finddr="
set "usbdr="
set /a "drnum=1"
for /f "tokens=*" %%A in ('fsutil fsinfo drives^|find /V ""') do (
    set "dr=%%A"
    call set "drlist=%%drlist%% %%dr:~-3%%"
)

for %%A in (%drlist%) do (
call set "drtype=%%A"
call set "finddr=%%A"
call :setdrtype
)
goto :Last

:setdrtype
set "drlistfin="
for /f "tokens=1,* delims=:\- " %%B  in ('fsutil fsinfo drivetype %drtype%^|find "Removable Drive"') do (
set /a "drnum+=1"
	if NOT "%finddr:~-1%" == "\" (set "finddr=%finddr%\")
echo.%drnum%#%finddr%#;>>"%LLTTempPath%\%LLTTempSubP%\USBdrletter.txt"
)
goto :eof

:copyUSBkey
set "USBtardrive="
    cls
if ."%opt%". == ."Factory Download". (
echo.
echo.                    *** Factory Download Package is selected ***
)
echo.
echo.%Tline1% 
echo.%Tline2%
echo.                           %opt% Options 
echo.--------------------------+---------------------------+---------------------------
echo.
echo.                  %TEMPPKGDISPNM% temp PKG to be copied to %TEMPPKGDISPNM% Flash Drive:
echo.                  ---------------------------------------------
   	for /f "tokens=* usebackq delims=#" %%x in ("%LLTTempPath%\%LLTTempSubP%\USBpkgStat.txt") do (
   	echo.                     - %%x
   	)
echo.
echo.                  ---------------------------------------------
echo.%splitL%
echo.  
if EXIST "%LLTTempPath%\%LLTTempSubP%\USBdrletter.txt" (
    FOR /F "eol=; tokens=1,2,* usebackq delims=#" %%y in ("%LLTTempPath%\%LLTTempSubP%\USBdrletter.txt") do (
        if NOT "%%y" == "" (
        echo.                 Please select: 
        echo.                
        echo.
		echo.                  *  %%y: %%z ^(Copy %TEMPPKGDISPNM% PKG to %%z%pkgDLType%^)
		) ELSE (
		echo.                
		echo. 
		)
    )
echo.
) ELSE (
echo.                
echo. 
)
echo.                     B = go Back
echo.
echo.                         
echo.%Tline3%
echo. %TEMPPKGDISPNM% Download MODE^: %TEMPPKGDISPNM% Flash Drive formated with^: FAT16 or FAT32.
echo.%splitL%
echo.

if "%numb%" == "1" (
echo. 	      * Invalid option entered ... *
echo.                  
)
set "USBoption="
set /p USBoption="* Please enter target %TEMPPKGDISPNM% drive: "
echo.
if "%USBoption%" == "" (
set "numb=1"
goto :copyUSBkey
)

if /I "%USBoption%" == "B" (
set "option="
set "numb=0"
set "noUSBkey=3"
goto :RESMenu
)

if "%USBoption:~1,1%" == ":" (
    if NOT "%USBoption:~-1%" == "\" (
    call set "USBoption=%USBoption%\"
    )
)

set "USBtardrive=%USBoption%"
if NOT "%USBoption:~1,1%" == ":" (
    if EXIST "%LLTTempPath%\%LLTTempSubP%\USBdrletter.txt" (
        FOR /F "eol=; tokens=1,2,* usebackq delims=#" %%y in ("%LLTTempPath%\%LLTTempSubP%\USBdrletter.txt") do (
    	    if "%%y" == "%USBoption%" (
    	    set "numb=0"
    	    set "option="
    	    set "usbdrivecp=%%z"
    	        if EXIST "%%z" (
                    if EXIST "%%z%pkgDLType%" (
                    set "chknb=0"
                    call :confirmUSBcp
                    ) ELSE (
                    xcopy /R /Q /S /Y "%LLTTempPath%\%LLTTempSubP%\%TEMPPKGPATH%\%pkgDLType%" "%%z%pkgDLType%\" >Nul
                        if ERRORLEVEL 0 (
                        set "doneUSBcp=1"
                        set "orginUSBdr=%%z"
                        set "noUSBkey=0"
                        ) ELSE (
                        set "noUSBkey=2"
                        )
                    )
                ) ELSE (
                set "option="
                set "noUSBkey=1"
                )
    	    goto :RESMenu
    	    )
    	)
    ) 
) ELSE (
    if NOT "%USBoption:~1,3%" == ":\" (
    set "numb=1"
    goto :copyUSBkey
    )
    call set "usbdrivecp=%USBoption%"
    if EXIST "%USBoption%" (
        if EXIST "%USBoption%%pkgDLType%" (
        set "chknb=0"
        call :confirmUSBcp
        ) ELSE (
        xcopy /R /Q /S /Y "%LLTTempPath%\%LLTTempSubP%\%TEMPPKGPATH%\%pkgDLType%" "%USBoption%%pkgDLType%\" >Nul
            if ERRORLEVEL 0 (
            set "doneUSBcp=1"
            set "orginUSBdr=%USBoption%"
            set "noUSBkey=0"
            ) ELSE (
            set "noUSBkey=2"
            )
        )
    set "option="
    goto :RESMenu
    )
)
set "numb=1"
goto :copyUSBkey

:confirmUSBcp
set "cfmoption="
echo.
if "%chknb%" == "1" (
echo. 	      * Invalid option selected ... *
echo.                  
)
echo.* There is an existing %TEMPPKGDISPNM% PKG on "%usbdrivecp%" drive,
set /P cfmoption=  do you want to replace the existing %TEMPPKGDISPNM% PKG? Y/N:  
echo.
if "%cfmoption%" == "" (
goto :confirmUSBcp
)


if /I "%cfmoption%" == "Y" (
set "chknb=0"
rmdir /Q /S "%usbdrivecp%%pkgDLType%" >Nul
verify >nul 
xcopy /R /Q /S /Y "%LLTTempPath%\%LLTTempSubP%\%TEMPPKGPATH%\%pkgDLType%" "%usbdrivecp%%pkgDLType%\" >Nul
    if ERRORLEVEL 0 (
    set "doneUSBcp=1"
    set "orginUSBdr=%usbdrivecp%"
    set "noUSBkey=0"
    ) ELSE (
    set "noUSBkey=2"
    )
goto :eof
) ELSE (
    if /I "%cfmoption%" == "N" (
    set "chknb=0"
    set "noUSBkey=3"
    goto :eof
    )
)
set "chknb=1"
goto :confirmUSBcp

:loadSelected
COLOR 17
FOR /F "eol=; tokens=* delims=#" %%f in ("%perlj%") do (
set FNdelCat=%%~nf
)

if "%PKGtypeIndicator%" == "1" (
	echo.* Creating %TEMPPKGDISPNM% Temporary Package ...
	call :catName
	call :USBPKGCreate
) ELSE (
	if "%PKGtypeIndicator%" == "3" (
	echo.* Creating %TEMPPKGDISPNM% Temporary Package ...
	call :catName
	call :USBPKGCreate
	) else (
		if "%DEDTF%" == "1" (
			if NOT EXIST "%LLTTempPath%\%LLTTempSubP%\TEMPPKG\delDataF_%FNdelCat%.Mxx" (
			echo.  Please wait ...
			echo.
			call :catName
				FOR /F "eol=; tokens=* usebackq delims=#" %%c in ("%LLTTempPath%\%LLTTempSubP%\TEMPPKG\%perlj%") do (
				set "pertc=%%c"
				set "Filename=%%~nc"
				call :DelDataCatF
				)
			) 

			if EXIST "%LLTTempPath%\%LLTTempSubP%\TEMPPKG\delDataF_%FNdelCat%.Mxx" (
			set "deleteDataFList=%LLTTempPath%\%LLTTempSubP%\TEMPPKG\delDataF_%FNdelCat%.Mxx"
			call :DelDataGO
			)
		)

		call :GO

		:LLTswitchDLL
		if "%LLTtoolType%" == "1" (goto :jLLTDLL) 

		"%LLT%" -c%LLTTempPath%\%LLTTempSubP%\TEMPPKG\%perlj% -eSWAP -a1 -x%NB% -r%LLTTempPath%\%LLTTempSubP%\TEMPPKG\Batchlog.txt
		
		goto :doneDLL

		:jLLTDLL
		:: Adding jLLT code
		if "%TeliumTYPE%" == "2" (
		set "ANT_TARGET=load_T2"
		call :Telium2xml
		) ELSE (
			if "%TeliumTYPE%" == "3" (
			set "ANT_TARGET=load_TETRA"
			call :Telium3xml
			)
		)

		if .%ANT_TARGET% equ . (
			echo Calling the default ANT target...
		) else (
			echo Calling the "%ANT_TARGET%" ANT target...
		)
		cd /d "%LLTTempPath%\%LLTTempSubP%\TEMPPKG"
		
		set "VERBOSE="
		set "VERBOSE=-Dverbose"
		set "LOG_FILE=%LLTTempPath%\workspace\.metadata\.log"
		set "DATETIME=%DATE:/=%-%TIME::=%"
		set "DATETIME=%DATETIME:,=%"
		if exist "%LOG_FILE%" (
		move "%LOG_FILE%" "%LLTTempPath%\workspace\.metadata\%DATETIME%.log"
		rem.>"%LOG_FILE%"
		)
		if exist "%result_file%" (Del /S /Q "%result_file%">Nul)
		call "%LLT%" --launcher.suppressErrors -nosplash -application org.eclipse.ant.core.antRunner %VERBOSE% -D%NB% -buildfile "jLLTdownload.xml" %ANT_TARGET%

		set "Retcode=%ERRORLEVEL%"
		if EXIST "%result_file%" (
			for /f "tokens=1,* delims=	 " %%G IN ('type "%result_file%"') DO (
			set "errcode=%%G"
			set "errDescription=%%H"
			)
		)
		if NOT "%Retcode%" == "0" (
		echo.-%Retcode%>"%LLTTempPath%\%LLTTempSubP%\TEMPPKG\Batchlog.txt"
		) else (
		echo.%Retcode%>"%LLTTempPath%\%LLTTempSubP%\TEMPPKG\Batchlog.txt"
		)

	:doneDLL
	set "newsession=0"
	)
)
goto :Last

:Telium3xml
echo.^<^?xml version ^= ^"1.0^" encoding ^= ^"ISO^-8859^-1^"^?^>>"%LLTTempPath%\%LLTTempSubP%\TEMPPKG\jLLTdownload.xml"
echo.^<project>>"%LLTTempPath%\%LLTTempSubP%\TEMPPKG\jLLTdownload.xml"
echo.    name ^= ^"Loader^">>"%LLTTempPath%\%LLTTempSubP%\TEMPPKG\jLLTdownload.xml"
echo.    basedir ^= ^".^">>"%LLTTempPath%\%LLTTempSubP%\TEMPPKG\jLLTdownload.xml"
echo.    default ^= ^"%ANT_TARGET%^"^>>>"%LLTTempPath%\%LLTTempSubP%\TEMPPKG\jLLTdownload.xml"
echo.    ^<^^!^-^-For Telium TETRA terminals ^-^-^>>>"%LLTTempPath%\%LLTTempSubP%\TEMPPKG\jLLTdownload.xml"
echo.    ^<target name ^= ^"%ANT_TARGET%^"^>>>"%LLTTempPath%\%LLTTempSubP%\TEMPPKG\jLLTdownload.xml"
:: added for log download error
echo.        ^<jllt.commandLineTask>>"%LLTTempPath%\%LLTTempSubP%\TEMPPKG\jLLTdownload.xml"
echo.            action ^= ^"enable^">>"%LLTTempPath%\%LLTTempSubP%\TEMPPKG\jLLTdownload.xml"
echo.            option ^= ^"result file^">>"%LLTTempPath%\%LLTTempSubP%\TEMPPKG\jLLTdownload.xml"
echo.            target ^= ^"%result_file%^"^/^>>>"%LLTTempPath%\%LLTTempSubP%\TEMPPKG\jLLTdownload.xml"
::----------------

echo.        ^<jllt.commandLineTask>>"%LLTTempPath%\%LLTTempSubP%\TEMPPKG\jLLTdownload.xml"
echo.            action ^= ^"connect^">>"%LLTTempPath%\%LLTTempSubP%\TEMPPKG\jLLTdownload.xml"
echo.            device ^= ^"COM%NB%^"^/^>>>"%LLTTempPath%\%LLTTempSubP%\TEMPPKG\jLLTdownload.xml"
echo.        ^<jllt.commandLineTask>>"%LLTTempPath%\%LLTTempSubP%\TEMPPKG\jLLTdownload.xml"
echo.            action ^= ^"terminals^">>"%LLTTempPath%\%LLTTempSubP%\TEMPPKG\jLLTdownload.xml"
echo.            target ^= ^"C^:^\^\Terminals.txt^"^/^>>>"%LLTTempPath%\%LLTTempSubP%\TEMPPKG\jLLTdownload.xml"

echo.        ^<jllt.commandLineTask>>"%LLTTempPath%\%LLTTempSubP%\TEMPPKG\jLLTdownload.xml"
echo.            action ^= ^"download^">>"%LLTTempPath%\%LLTTempSubP%\TEMPPKG\jLLTdownload.xml"
echo.            source ^= ^"%LLTTempPath%\%LLTTempSubP%\TEMPPKG\%perlj%^"^/^>>>"%LLTTempPath%\%LLTTempSubP%\TEMPPKG\jLLTdownload.xml"

echo.        ^<jllt.commandLineTask action ^= ^"disconnect^"^/^>>>"%LLTTempPath%\%LLTTempSubP%\TEMPPKG\jLLTdownload.xml"
echo.    ^<^/target^>>>"%LLTTempPath%\%LLTTempSubP%\TEMPPKG\jLLTdownload.xml"
echo.^<^/project^>>>"%LLTTempPath%\%LLTTempSubP%\TEMPPKG\jLLTdownload.xml"
goto :Last

:Telium2xml
echo.^<^?xml version ^= ^"1.0^" encoding ^= ^"ISO^-8859^-1^"^?^>>"%LLTTempPath%\%LLTTempSubP%\TEMPPKG\jLLTdownload.xml"
echo.^<project>>"%LLTTempPath%\%LLTTempSubP%\TEMPPKG\jLLTdownload.xml"
echo.    name ^= ^"Loader^">>"%LLTTempPath%\%LLTTempSubP%\TEMPPKG\jLLTdownload.xml"
echo.    basedir ^= ^".^">>"%LLTTempPath%\%LLTTempSubP%\TEMPPKG\jLLTdownload.xml"
echo.    default ^= ^"%ANT_TARGET%^"^>>>"%LLTTempPath%\%LLTTempSubP%\TEMPPKG\jLLTdownload.xml"
echo.    ^<^^!^-^-For Telium 2 terminals ^-^-^>>>"%LLTTempPath%\%LLTTempSubP%\TEMPPKG\jLLTdownload.xml"
echo.    ^<target name ^= ^"%ANT_TARGET%^"^>>>"%LLTTempPath%\%LLTTempSubP%\TEMPPKG\jLLTdownload.xml"
:: added for log download error
echo.        ^<jllt.commandLineTask>>"%LLTTempPath%\%LLTTempSubP%\TEMPPKG\jLLTdownload.xml"
echo.            action ^= ^"enable^">>"%LLTTempPath%\%LLTTempSubP%\TEMPPKG\jLLTdownload.xml"
echo.            option ^= ^"result file^">>"%LLTTempPath%\%LLTTempSubP%\TEMPPKG\jLLTdownload.xml"
echo.            target ^= ^"%result_file%^"^/^>>>"%LLTTempPath%\%LLTTempSubP%\TEMPPKG\jLLTdownload.xml"
::----------------
echo.        ^<jllt.commandLineTask>>"%LLTTempPath%\%LLTTempSubP%\TEMPPKG\jLLTdownload.xml"
echo.            action ^= ^"connect^">>"%LLTTempPath%\%LLTTempSubP%\TEMPPKG\jLLTdownload.xml"
echo.            device ^= ^"COM%NB%^"^/^>>>"%LLTTempPath%\%LLTTempSubP%\TEMPPKG\jLLTdownload.xml"
echo.        ^<jllt.commandLineTask>>"%LLTTempPath%\%LLTTempSubP%\TEMPPKG\jLLTdownload.xml"
echo.            action ^= ^"terminals^">>"%LLTTempPath%\%LLTTempSubP%\TEMPPKG\jLLTdownload.xml"
echo.            target ^= ^"C^:^\^\Terminals.txt^"^/^>>>"%LLTTempPath%\%LLTTempSubP%\TEMPPKG\jLLTdownload.xml"

echo.        ^<jllt.commandLineTask>>"%LLTTempPath%\%LLTTempSubP%\TEMPPKG\jLLTdownload.xml"
echo.            action ^= ^"download^">>"%LLTTempPath%\%LLTTempSubP%\TEMPPKG\jLLTdownload.xml"
echo.            source ^= ^"%LLTTempPath%\%LLTTempSubP%\TEMPPKG\%perlj%^"^/^>>>"%LLTTempPath%\%LLTTempSubP%\TEMPPKG\jLLTdownload.xml"

echo.        ^<jllt.commandLineTask action ^= ^"disconnect^"^/^>>>"%LLTTempPath%\%LLTTempSubP%\TEMPPKG\jLLTdownload.xml"
echo.    ^<^/target^>>>"%LLTTempPath%\%LLTTempSubP%\TEMPPKG\jLLTdownload.xml"
echo.^<^/project^>>>"%LLTTempPath%\%LLTTempSubP%\TEMPPKG\jLLTdownload.xml"
goto :Last

:COMSel
set "NBT=1"
set "m=0"
set "chkLines="

if "%PKGtypeIndicator%" == "0" (
call :ReENTCOM
) 
call :StoreParam
if "%PORT%" == "X" ( goto :Exit )
goto :FileCopy

:LLTSelCHK
if NOT "%PKGtypeIndicator%" == "0" ( goto :FileCopy )

set "m=0"
set "chkLines="
set "PORT="

if EXIST "%LLTPATH%\%LLTtoolName%" ( goto :Default ) 
set "resetLLT=1"
goto :LLTSel

:LLTSel
cd /d "%SystemDrive%\"
:Skipx86
set "DPATHdisp="
cls
echo.
call :getInstPath
cls
echo.
echo.%Tline1% 
echo.%Tline2%
if EXIST "%LLTTempPath%\LocalLLTPath.txt" (
set /a "dLLTpath=0"
	FOR /F "tokens=1,2,3 usebackq delims=#" %%s in ("%LLTTempPath%\LocalLLTPath.txt") do (
		if "%%t" == "%LLTPATH%" (
		set /a "dLLTpath+=1"
		) 
	)
)
if EXIST "%LLTTempPath%\LocalLLTPath.txt" (
echo.
echo.%splitL%
echo.                        LLT tool installed on this PC
echo.                    -------------------------------------
echo.
	FOR /F "tokens=1,2,3,4,5,6 usebackq delims=#" %%a in ("%LLTTempPath%\LocalLLTPath.txt") do (
		if "%%a" == "0" (
			if /I "%%f" == "0" (
			echo.                 %%d: LLT Version - %%c
			) else (
				if /I "%%f" == "1" (
				echo.                 %%d: jLLT Version - %%c
				)
			)
			if "%dLLTpath%" == "0" (
				if "%%d" == "1" (set "DPATHdisp=%%b")
			)
		) 
	)
	
echo.
echo.%splitL%
)
echo.
echo.                  U = Use %TEMPPKGDISPNM% package download
echo.                  F = Find jLLT on All Local Drives
echo.
echo.                      X = Exit
echo.
if NOT EXIST "%LLTPATH%\%LLTtoolName%" ( 
	if NOT EXIST "%DPATHdisp%\%LLTtoolName%" ( 
	set "DispLLTExist=* Enter LLT installation path:"
	) ELSE (
	set "LLTPATH=%DPATHdisp%"
	set "DispLLTExist=* Enter LLT path, enter LLT tool option above, or press [ENTER] for"
	)
echo.%Tline3%
echo.* Could not find the %LLTtoolName% under "%LLTPATH%".
) else (
set "DispLLTExist=* Enter LLT path, enter LLT tool option above, or press [ENTER] for"
)
echo.%Tline3%
if "%DPATHdisp%" == "" (
	if "%resetLLT%" == "1" (
	set "DPATHdisp=%LLTPATH%"
	) else (
	set "DPATHdisp=%DPATH%"
	)
)
set "DPATHdisp=%DPATHdisp:(=[%"
set "DPATHdisp=%DPATHdisp:)=]%"
echo.%splitL%
echo.%DispLLTExist%

if NOT EXIST "%LLTPATH%\%LLTtoolName%" ( 
set /p LLT_TOOLS=  
) else (
set /p LLT_TOOLS=  %DPATHdisp% : 
)
if NOT ."%LLT_TOOLS%". == ."". (
set "LLT_TOOLS=%LLT_TOOLS:"=%"
)

if ."%LLT_TOOLS%". == ."". (set "LLT_TOOLS=%DPATHdisp%")
if /I "%LLT_TOOLS%" == "X" (goto :Exit)
if /I "%LLT_TOOLS%" == "U" (
set "m=0"
set "TEMPPKGDISPNM=USB"
set "TEMPPKGPATH=USBPKG"
set "PKGtypeIndicator=1"
set "qaParam=/USB"
	if /I "%FileCopied%" == "0" (
	goto :FileCopy
	) else (
	goto :RESMenu
	)

)

if /I "%LLT_TOOLS%" == "F" ( 
	if "%PKGtypeIndicator%" == "0" (
	set "m=0"
	set "resetLLT=1"
	::FullFindjLLT
	echo. This may take a while ...
	set "PartialChk=0" 
	goto :LLTSel
	) 
)

if EXIST "%LLTTempPath%\LocalLLTPath.txt" (
	FOR /F "tokens=1,2,3,4,5,6 usebackq delims=#" %%a in ("%LLTTempPath%\LocalLLTPath.txt") do (
		if "%%a" == "0" (
			if "%%d" == "%LLT_TOOLS%" (
			set "LLT_TOOLS=%%b"
			set "LLTtempFileName=%%e"
			set "LLTtoolType=%%f"
			)
		) 
	)
)

if EXIST "%LLT_TOOLS%" (
set "PATH=%TPATH%;%LLT_TOOLS%" 
set "LLTPATH=%LLT_TOOLS%"
set "LLTtoolName=%LLTtempFileName%"
)
goto :LLTCHK

:chgLLTFname
echo.
echo. --------------------------------------------
echo. * LLT file: ^"%LLTtoolName%^" does not exist,
echo. * Please try another LLT file Name. 
echo.
echo. * Enter "B" to go back ....
echo.
echo. --------------------------------------------
echo.
if "%m%" == "1" (
echo.  - Invalid file name is entered -
echo.
)
if "%m%" == "2" (
echo.  - File name "%option%" does not exist -
echo.
)
set "option="
set /p "option=  Please enter the new LLT file name: "

if /I "%option%" == "" (
set "m=1"
goto :chgLLTFname
)
if EXIST "%LLTPATH%\%option%" (
set "m=0"
set "LLTtoolName=%option%"
goto :LLTSelCHK
) ELSE (
	if /I "%option%" == "B" (
	set "m=0"
	goto :LLTSelCHK
	) ELSE (
	set "m=2"
	goto :chgLLTFname
	)
)
goto :eof

:Default
set "PATH=%TPATH%;%LLTPATH%"
set "DPATH=%LLTPATH%"

:LLTCHK
set "LLT=%LLTPATH%\%LLTtoolName%"
if EXIST "%LLTPATH%\configuration" (
	if NOT EXIST "%LLTPATH%\ras" (
	set "LLTtoolType=1"
	)
)

if "%FileCopied%" == "0" (
	IF EXIST "%LLT%" (
	goto :COMSel
	)
) 
IF EXIST "%LLT%" (
call :StoreParam
	if "%resetLLT%" == "1" (
	goto :RESMenu
	) ELSE (
	goto :COMSel
	)
) ELSE (
goto :LLTSel
)

:DelDataGO
COLOR 17
cls
if ."%opt%". == ."Factory Download". (
echo.
echo.                    *** Factory Download Package is selected ***
)
Echo.
Echo.%Tline1% 
echo.%Tline2%
echo.                       %opt% - Delete Data File
echo.---------------------+----------------------------------+-------------------------
echo.
echo.               Data files below in %datafolder% drive will be deleted:
echo.              
FOR /F "eol=; tokens=1,* usebackq delims=;" %%y in ("%deleteDataFList%") do (
    if NOT "%%y" == "-e%datafolder%" ( 
    echo.                  %%y
    )
)
echo.              
echo.              **************************************************
echo.              * Errors may display if data file does not EXIST *
echo.              **************************************************
echo.
echo.          ------------------------------------------------------------
echo.%Tline3%
echo.    %LLTtoolName% PATH: "%LLTPATH%"
echo.    COM PORT: COM%NB% ^(%COMSTATUS%^)
echo.%date%-%time%: Download utility %LLT% is selected >>"%ALLUSERSPROFILE%\LLTTemp\log\download.log"
echo.%date%-%time%: COM %NB% is selected >>"%ALLUSERSPROFILE%\LLTTemp\log\download.log"
echo.%date%-%time%: Attempting to Delete Data file in Terminal >>"%ALLUSERSPROFILE%\LLTTemp\log\download.log"
echo.%splitL%
echo.
echo.* Please launch LLT on the terminal
set /p T=  When "LLT" displayed, press Enter Key to continue ...
echo.
echo.* Attempt to Delete Data Files from Terminal ...
:LLTswitchDEL
if "%LLTtoolType%" == "1" (goto :jLLTDELData) 
"%LLT%" -d%deleteDataFList% -e%datafolder% -a1 -x%NB% -r%LLTTempPath%\%LLTTempSubP%\TEMPPKG\Batchlog.txt

goto :doneDEL

:jLLTDELData
::----------------Start jLLT DEL Data-------------------------------
:: Adding jLLT code
if "%TeliumTYPE%" == "2" (
set "ANT_TARGET=load_T2DEL"
call :Telium2xmlDEL
) ELSE (
	if "%TeliumTYPE%" == "3" (
	set "ANT_TARGET=load_TETRADEL"
	call :Telium3xmlDEL
	)
)

if .%ANT_TARGET% equ . (
	echo Calling the default ANT target...
) else (
	echo Calling the "%ANT_TARGET%" ANT target...
)

cd /d "%LLTTempPath%\%LLTTempSubP%\TEMPPKG"

set "VERBOSE="
set "VERBOSE=-Dverbose"
set "LOG_FILE=%LLTTempPath%\workspace\.metadata\.log"
set "DATETIME=%DATE:/=%-%TIME::=%"
set "DATETIME=%DATETIME:,=%"
if exist "%LOG_FILE%" (
	move "%LOG_FILE%" "%LLTTempPath%\workspace\.metadata\%DATETIME%.log"
	rem.>"%LOG_FILE%"
)
if exist "%result_file%" (Del /S /Q "%result_file%">Nul)
call "%LLT%" --launcher.suppressErrors -nosplash -application org.eclipse.ant.core.antRunner %VERBOSE% -D%NB% -buildfile "jLLTdownload.xml" %ANT_TARGET%

set "Retcode=%ERRORLEVEL%"

if EXIST "%result_file%" (
	for /f "tokens=1,* delims=	 " %%G IN ('type "%result_file%"') DO (
	set "errcode=%%G"
	set "errDescription=%%H"
	)
)

if NOT "%Retcode%" == "0" (
echo.-%Retcode%>"%LLTTempPath%\%LLTTempSubP%\TEMPPKG\Batchlog.txt"
) else (
echo.%Retcode%>"%LLTTempPath%\%LLTTempSubP%\TEMPPKG\Batchlog.txt"
)
::----------------End jLLT DEL Data-------------------------------

:doneDEL
set "newsession=0"
goto :Last


:Telium2xmlDEL
echo.^<^?xml version ^= ^"1.0^" encoding ^= ^"ISO^-8859^-1^"^?^>>"%LLTTempPath%\%LLTTempSubP%\TEMPPKG\jLLTdownload.xml"
echo.^<project>>"%LLTTempPath%\%LLTTempSubP%\TEMPPKG\jLLTdownload.xml"
echo.    name ^= ^"Loader^">>"%LLTTempPath%\%LLTTempSubP%\TEMPPKG\jLLTdownload.xml"
echo.    basedir ^= ^".^">>"%LLTTempPath%\%LLTTempSubP%\TEMPPKG\jLLTdownload.xml"
echo.    default ^= ^"%ANT_TARGET%^"^>>>"%LLTTempPath%\%LLTTempSubP%\TEMPPKG\jLLTdownload.xml"
echo.    ^<^^!^-^-For Telium 2 terminals ^-^-^>>>"%LLTTempPath%\%LLTTempSubP%\TEMPPKG\jLLTdownload.xml"
echo.    ^<target name ^= ^"%ANT_TARGET%^"^>>>"%LLTTempPath%\%LLTTempSubP%\TEMPPKG\jLLTdownload.xml"
:: added for log download error
echo.        ^<jllt.commandLineTask>>"%LLTTempPath%\%LLTTempSubP%\TEMPPKG\jLLTdownload.xml"
echo.            action ^= ^"enable^">>"%LLTTempPath%\%LLTTempSubP%\TEMPPKG\jLLTdownload.xml"
echo.            option ^= ^"result file^">>"%LLTTempPath%\%LLTTempSubP%\TEMPPKG\jLLTdownload.xml"
echo.            target ^= ^"%result_file%^"^/^>>>"%LLTTempPath%\%LLTTempSubP%\TEMPPKG\jLLTdownload.xml"
::----------------
echo.        ^<jllt.commandLineTask>>"%LLTTempPath%\%LLTTempSubP%\TEMPPKG\jLLTdownload.xml"
echo.            action ^= ^"connect^">>"%LLTTempPath%\%LLTTempSubP%\TEMPPKG\jLLTdownload.xml"
echo.            device ^= ^"COM%NB%^"^/^>>>"%LLTTempPath%\%LLTTempSubP%\TEMPPKG\jLLTdownload.xml"
echo.        ^<jllt.commandLineTask>>"%LLTTempPath%\%LLTTempSubP%\TEMPPKG\jLLTdownload.xml"
echo.            action ^= ^"terminals^">>"%LLTTempPath%\%LLTTempSubP%\TEMPPKG\jLLTdownload.xml"
echo.            target ^= ^"C^:^\^\Terminals.txt^"^/^>>>"%LLTTempPath%\%LLTTempSubP%\TEMPPKG\jLLTdownload.xml"

for /f "tokens=* delims=" %%G IN ('type "%deleteDataFList%"') DO (
echo.        ^<jllt.commandLineTask>>"%LLTTempPath%\%LLTTempSubP%\TEMPPKG\jLLTdownload.xml"
echo.            action ^= ^"delete^">>"%LLTTempPath%\%LLTTempSubP%\TEMPPKG\jLLTdownload.xml"
echo.            target ^= ^"/%datafolder%/%%G^"^/^>>>"%LLTTempPath%\%LLTTempSubP%\TEMPPKG\jLLTdownload.xml"
)

echo.        ^<jllt.commandLineTask action ^= ^"disconnect^"^/^>>>"%LLTTempPath%\%LLTTempSubP%\TEMPPKG\jLLTdownload.xml"
echo.    ^<^/target^>>>"%LLTTempPath%\%LLTTempSubP%\TEMPPKG\jLLTdownload.xml"
echo.^<^/project^>>>"%LLTTempPath%\%LLTTempSubP%\TEMPPKG\jLLTdownload.xml"

goto :Last

:Telium3xmlDEL
echo.^<^?xml version ^= ^"1.0^" encoding ^= ^"ISO^-8859^-1^"^?^>>"%LLTTempPath%\%LLTTempSubP%\TEMPPKG\jLLTdownload.xml"
echo.^<project>>"%LLTTempPath%\%LLTTempSubP%\TEMPPKG\jLLTdownload.xml"
echo.    name ^= ^"Loader^">>"%LLTTempPath%\%LLTTempSubP%\TEMPPKG\jLLTdownload.xml"
echo.    basedir ^= ^".^">>"%LLTTempPath%\%LLTTempSubP%\TEMPPKG\jLLTdownload.xml"
echo.    default ^= ^"%ANT_TARGET%^"^>>>"%LLTTempPath%\%LLTTempSubP%\TEMPPKG\jLLTdownload.xml"
echo.    ^<^^!^-^-For Telium TETRA terminals ^-^-^>>>"%LLTTempPath%\%LLTTempSubP%\TEMPPKG\jLLTdownload.xml"
echo.    ^<target name ^= ^"%ANT_TARGET%^"^>>>"%LLTTempPath%\%LLTTempSubP%\TEMPPKG\jLLTdownload.xml"
:: added for log download error
echo.        ^<jllt.commandLineTask>>"%LLTTempPath%\%LLTTempSubP%\TEMPPKG\jLLTdownload.xml"
echo.            action ^= ^"enable^">>"%LLTTempPath%\%LLTTempSubP%\TEMPPKG\jLLTdownload.xml"
echo.            option ^= ^"result file^">>"%LLTTempPath%\%LLTTempSubP%\TEMPPKG\jLLTdownload.xml"
echo.            target ^= ^"%result_file%^"^/^>>>"%LLTTempPath%\%LLTTempSubP%\TEMPPKG\jLLTdownload.xml"
::----------------
echo.        ^<jllt.commandLineTask>>"%LLTTempPath%\%LLTTempSubP%\TEMPPKG\jLLTdownload.xml"
echo.            action ^= ^"connect^">>"%LLTTempPath%\%LLTTempSubP%\TEMPPKG\jLLTdownload.xml"
echo.            device ^= ^"COM%NB%^"^/^>>>"%LLTTempPath%\%LLTTempSubP%\TEMPPKG\jLLTdownload.xml"
echo.        ^<jllt.commandLineTask>>"%LLTTempPath%\%LLTTempSubP%\TEMPPKG\jLLTdownload.xml"
echo.            action ^= ^"terminals^">>"%LLTTempPath%\%LLTTempSubP%\TEMPPKG\jLLTdownload.xml"
echo.            target ^= ^"C^:^\^\Terminals.txt^"^/^>>>"%LLTTempPath%\%LLTTempSubP%\TEMPPKG\jLLTdownload.xml"

for /f "tokens=* delims=" %%G IN ('type "%deleteDataFList%"') DO (
echo.        ^<jllt.commandLineTask>>"%LLTTempPath%\%LLTTempSubP%\TEMPPKG\jLLTdownload.xml"
echo.            action ^= ^"delete^">>"%LLTTempPath%\%LLTTempSubP%\TEMPPKG\jLLTdownload.xml"
echo.            target ^= ^"/import/%%G^"^/^>>>"%LLTTempPath%\%LLTTempSubP%\TEMPPKG\jLLTdownload.xml"
)

echo.        ^<jllt.commandLineTask action ^= ^"disconnect^"^/^>>>"%LLTTempPath%\%LLTTempSubP%\TEMPPKG\jLLTdownload.xml"
echo.    ^<^/target^>>>"%LLTTempPath%\%LLTTempSubP%\TEMPPKG\jLLTdownload.xml"
echo.^<^/project^>>>"%LLTTempPath%\%LLTTempSubP%\TEMPPKG\jLLTdownload.xml"
goto :Last

:GO
set "ResultCHK="
set "RetcodeCHK="
cls

if NOT "%opt%" == "Factory Download" (goto :SkipFacDisp)
echo.
echo.                    *** Factory Download Package is selected ***

set "dllMEMapp=%dllMEMapp:;=%"
set "DisaMemDLL=%DisaMemDLL:;=%"

if "%dllMEMapp%" == "" (set "dllMEMapp=0")
if "%dllMEMapp%" == "NA" (set "dllMEMapp=0")

if "%DisaMemDLL%" == "" (set "DisaMemDLL=0")
if "%DisaMemDLL%" == "NA" (set "DisaMemDLL=0")

if "%dllMEMapp%" == "0" (goto :SkipMEMDLL)
if "%DisaMemDLL%" == "0" (goto :SkipMEMDLL)

if NOT EXIST "%MEMSizeCATfileName%" (goto :SkipFacDisp)
Echo.
echo.%Tline1% 
echo.%Tline2%
echo.                             %opt%
echo.--------------------------+---------------------------+---------------------------
echo.
echo.           * Download Memory Sizing Application is required:
echo.             
echo.             After Memory Sizing Application download finished, let 
echo.             Terminal reboot and set terminal to LLT mode ... 
echo.
echo.           ------------------------------------------------------------
echo.%Tline3%
echo.    %LLTtoolName% PATH: "%LLTPATH%"
echo.    COM PORT: COM%NB% ^(%COMSTATUS%^)
echo.%date%-%time%: Download utility %LLT% is selected >>"%ALLUSERSPROFILE%\LLTTemp\log\download.log"
echo.%date%-%time%: COM %NB% is selected to load Memory Sizing Application>>"%ALLUSERSPROFILE%\LLTTemp\log\download.log"
echo.%splitL%
echo.
set "Tskip="
set /p Tskip=  * ERASE ALL, THEN REBOOT UNIT, ENTER TO CONTINUE, "S" to Skip ...
echo.
echo.* Download is started ...

if /I "%Tskip%" == "S" (goto :SkipMEMDLL)

:LLTswitchDLLmem
if "%LLTtoolType%" == "1" (goto :jLLTDLLmem) 
"%LLT%" -c%MEMSizeCATfileName% -eSWAP -a1 -x%NB% -r%LLTTempPath%\%LLTTempSubP%\TEMPPKG\Batchlog.txt

goto :doneDLLMem

:jLLTDLLmem
::----------------Start jLLT dll Mem-------------------------------
:: Adding jLLT code
if "%TeliumTYPE%" == "2" (
set "ANT_TARGET=load_T2MEM"
call :Telium2xmlMEM
) ELSE (
	if "%TeliumTYPE%" == "3" (
	set "ANT_TARGET=load_TETRAMEM"
	call :Telium3xmlMEM
	)
)

if .%ANT_TARGET% equ . (
	echo Calling the default ANT target...
) else (
	echo Calling the "%ANT_TARGET%" ANT target...
)

cd /d "%LLTTempPath%\%LLTTempSubP%\TEMPPKG"

set "VERBOSE="
set "VERBOSE=-Dverbose"
set "LOG_FILE=%LLTTempPath%\workspace\.metadata\.log"
set "DATETIME=%DATE:/=%-%TIME::=%"
set "DATETIME=%DATETIME:,=%"
if exist "%LOG_FILE%" (
	move "%LOG_FILE%" "%LLTTempPath%\workspace\.metadata\%DATETIME%.log"
	rem.>"%LOG_FILE%"
)
if exist "%result_file%" (Del /S /Q "%result_file%">Nul)
call "%LLT%" --launcher.suppressErrors -nosplash -application org.eclipse.ant.core.antRunner %VERBOSE% -D%NB% -buildfile "jLLTdownload.xml" %ANT_TARGET%

set "Retcode=%ERRORLEVEL%"
if EXIST "%result_file%" (
	for /f "tokens=1,* delims=	 " %%G IN ('type "%result_file%"') DO (
	set "errcode=%%G"
	set "errDescription=%%H"
	)
)

if NOT "%Retcode%" == "0" (
echo.-%Retcode%>"%LLTTempPath%\%LLTTempSubP%\TEMPPKG\Batchlog.txt"
) else (
echo.%Retcode%>"%LLTTempPath%\%LLTTempSubP%\TEMPPKG\Batchlog.txt"
)
::----------------End jLLT dll Mem-------------------------------
:doneDLLMem
set "newsession=0"
call :StatusCHK
if NOT "%RetcodeCHK%" == "0" (
COLOR 47
goto :GO
)

:SkipFacDisp
if "%newsession%" == "1" (goto :SkipMEMDLL)
if NOT "%dllMEMapp%" == "1" (goto :SkipMEMDLL)
if NOT EXIST "%MEMSizeCATfileName%" (goto :SkipMEMDLL)

:SkipMEMDLL
cls
COLOR 17
Echo.
Echo.%Tline1% 
echo.%Tline2%
echo.                             %opt%
echo.--------------------------+---------------------------+---------------------------
echo.
echo.           * Download option selected:
echo.             %perlk%
echo.
echo.           ------------------------------------------------------------
echo.%Tline3%
echo.    %LLTtoolName% PATH: "%LLTPATH%"
echo.    COM PORT: COM%NB% ^(%COMSTATUS%^)
echo.%date%-%time%: Download utility %LLT% is selected >>"%ALLUSERSPROFILE%\LLTTemp\log\download.log"
echo.%date%-%time%: COM %NB% is selected >>"%ALLUSERSPROFILE%\LLTTemp\log\download.log"
echo.%splitL%
echo.
echo.* Please launch LLT on the terminal
set /p T=  When "LLT" displayed, press Enter Key to continue ...
echo.
echo.* Download is started ...
goto :Last

:Telium2xmlMEM
echo.^<^?xml version ^= ^"1.0^" encoding ^= ^"ISO^-8859^-1^"^?^>>"%LLTTempPath%\%LLTTempSubP%\TEMPPKG\jLLTdownload.xml"
echo.^<project>>"%LLTTempPath%\%LLTTempSubP%\TEMPPKG\jLLTdownload.xml"
echo.    name ^= ^"Loader^">>"%LLTTempPath%\%LLTTempSubP%\TEMPPKG\jLLTdownload.xml"
echo.    basedir ^= ^".^">>"%LLTTempPath%\%LLTTempSubP%\TEMPPKG\jLLTdownload.xml"
echo.    default ^= ^"%ANT_TARGET%^"^>>>"%LLTTempPath%\%LLTTempSubP%\TEMPPKG\jLLTdownload.xml"
echo.    ^<^^!^-^-For Telium 2 terminals ^-^-^>>>"%LLTTempPath%\%LLTTempSubP%\TEMPPKG\jLLTdownload.xml"
echo.    ^<target name ^= ^"%ANT_TARGET%^"^>>>"%LLTTempPath%\%LLTTempSubP%\TEMPPKG\jLLTdownload.xml"
:: added for log download error
echo.        ^<jllt.commandLineTask>>"%LLTTempPath%\%LLTTempSubP%\TEMPPKG\jLLTdownload.xml"
echo.            action ^= ^"enable^">>"%LLTTempPath%\%LLTTempSubP%\TEMPPKG\jLLTdownload.xml"
echo.            option ^= ^"result file^">>"%LLTTempPath%\%LLTTempSubP%\TEMPPKG\jLLTdownload.xml"
echo.            target ^= ^"%result_file%^"^/^>>>"%LLTTempPath%\%LLTTempSubP%\TEMPPKG\jLLTdownload.xml"
::----------------
echo.        ^<jllt.commandLineTask>>"%LLTTempPath%\%LLTTempSubP%\TEMPPKG\jLLTdownload.xml"
echo.            action ^= ^"connect^">>"%LLTTempPath%\%LLTTempSubP%\TEMPPKG\jLLTdownload.xml"
echo.            device ^= ^"COM%NB%^"^/^>>>"%LLTTempPath%\%LLTTempSubP%\TEMPPKG\jLLTdownload.xml"
echo.        ^<jllt.commandLineTask>>"%LLTTempPath%\%LLTTempSubP%\TEMPPKG\jLLTdownload.xml"
echo.            action ^= ^"terminals^">>"%LLTTempPath%\%LLTTempSubP%\TEMPPKG\jLLTdownload.xml"
echo.            target ^= ^"C^:^\^\Terminals.txt^"^/^>>>"%LLTTempPath%\%LLTTempSubP%\TEMPPKG\jLLTdownload.xml"

echo.        ^<jllt.commandLineTask>>"%LLTTempPath%\%LLTTempSubP%\TEMPPKG\jLLTdownload.xml"
echo.            action ^= ^"download^">>"%LLTTempPath%\%LLTTempSubP%\TEMPPKG\jLLTdownload.xml"
echo.            source ^= ^"%MEMSizeCATfileName%^"^/^>>>"%LLTTempPath%\%LLTTempSubP%\TEMPPKG\jLLTdownload.xml"

echo.        ^<jllt.commandLineTask action ^= ^"disconnect^"^/^>>>"%LLTTempPath%\%LLTTempSubP%\TEMPPKG\jLLTdownload.xml"
echo.    ^<^/target^>>>"%LLTTempPath%\%LLTTempSubP%\TEMPPKG\jLLTdownload.xml"
echo.^<^/project^>>>"%LLTTempPath%\%LLTTempSubP%\TEMPPKG\jLLTdownload.xml"
goto :Last

:Telium3xmlMEM
echo.^<^?xml version ^= ^"1.0^" encoding ^= ^"ISO^-8859^-1^"^?^>>"%LLTTempPath%\%LLTTempSubP%\TEMPPKG\jLLTdownload.xml"
echo.^<project>>"%LLTTempPath%\%LLTTempSubP%\TEMPPKG\jLLTdownload.xml"
echo.    name ^= ^"Loader^">>"%LLTTempPath%\%LLTTempSubP%\TEMPPKG\jLLTdownload.xml"
echo.    basedir ^= ^".^">>"%LLTTempPath%\%LLTTempSubP%\TEMPPKG\jLLTdownload.xml"
echo.    default ^= ^"%ANT_TARGET%^"^>>>"%LLTTempPath%\%LLTTempSubP%\TEMPPKG\jLLTdownload.xml"
echo.    ^<^^!^-^-For Telium TETRA terminals ^-^-^>>>"%LLTTempPath%\%LLTTempSubP%\TEMPPKG\jLLTdownload.xml"
echo.    ^<target name ^= ^"%ANT_TARGET%^"^>>>"%LLTTempPath%\%LLTTempSubP%\TEMPPKG\jLLTdownload.xml"
:: added for log download error
echo.        ^<jllt.commandLineTask>>"%LLTTempPath%\%LLTTempSubP%\TEMPPKG\jLLTdownload.xml"
echo.            action ^= ^"enable^">>"%LLTTempPath%\%LLTTempSubP%\TEMPPKG\jLLTdownload.xml"
echo.            option ^= ^"result file^">>"%LLTTempPath%\%LLTTempSubP%\TEMPPKG\jLLTdownload.xml"
echo.            target ^= ^"%result_file%^"^/^>>>"%LLTTempPath%\%LLTTempSubP%\TEMPPKG\jLLTdownload.xml"
::----------------
echo.        ^<jllt.commandLineTask>>"%LLTTempPath%\%LLTTempSubP%\TEMPPKG\jLLTdownload.xml"
echo.            action ^= ^"connect^">>"%LLTTempPath%\%LLTTempSubP%\TEMPPKG\jLLTdownload.xml"
echo.            device ^= ^"COM%NB%^"^/^>>>"%LLTTempPath%\%LLTTempSubP%\TEMPPKG\jLLTdownload.xml"
echo.        ^<jllt.commandLineTask>>"%LLTTempPath%\%LLTTempSubP%\TEMPPKG\jLLTdownload.xml"
echo.            action ^= ^"terminals^">>"%LLTTempPath%\%LLTTempSubP%\TEMPPKG\jLLTdownload.xml"
echo.            target ^= ^"C^:^\^\Terminals.txt^"^/^>>>"%LLTTempPath%\%LLTTempSubP%\TEMPPKG\jLLTdownload.xml"

echo.        ^<jllt.commandLineTask>>"%LLTTempPath%\%LLTTempSubP%\TEMPPKG\jLLTdownload.xml"
echo.            action ^= ^"download^">>"%LLTTempPath%\%LLTTempSubP%\TEMPPKG\jLLTdownload.xml"
echo.            source ^= ^"%MEMSizeCATfileName%^"^/^>>>"%LLTTempPath%\%LLTTempSubP%\TEMPPKG\jLLTdownload.xml"

echo.        ^<jllt.commandLineTask action ^= ^"disconnect^"^/^>>>"%LLTTempPath%\%LLTTempSubP%\TEMPPKG\jLLTdownload.xml"
echo.    ^<^/target^>>>"%LLTTempPath%\%LLTTempSubP%\TEMPPKG\jLLTdownload.xml"
echo.^<^/project^>>>"%LLTTempPath%\%LLTTempSubP%\TEMPPKG\jLLTdownload.xml"
goto :Last


:StoreParam -- save User's COM port and LLT PATH information to %Tempcfgname%
if EXIST "%Tempcfgname%" (del /F "%Tempcfgname%")
if "%NB%" == "" (goto :eof)
if "%DPATH%" == "" (goto :eof)
echo.%date%-%time%: Save local configuration parameters to %Tempcfgname% >>"%ALLUSERSPROFILE%\LLTTemp\log\download.log"
echo 0#COM#%NB%#Default COM port on this PC#; >>"%Tempcfgname%"
echo 0#DPATH#%LLTPATH%#%LLTtoolName%#Default LLT PATH and Name on this PC#; >>"%Tempcfgname%"
echo 0#LLTtoolType#%LLTtoolType%#Default LLT Tool Type on this PC#; >>"%Tempcfgname%"
echo 0#LLTTempPath#%LLTTempPath%#Default PKG download Temp Path on this PC#; >>"%Tempcfgname%"
goto :eof

:isOSfolder
if "%tempsubdirName:~0,1%" == "\" (set "tempsubdirName=%tempsubdirName:~1%")
if "%tempsubdirName:~-1%" == "\" (set "tempsubdirName=%tempsubdirName:~0,-1%")
::------ Telium 2 OS-SDK ---------------
if "%TeliumTYPE%" == "3" (goto :isOSfolderT3)
if "%pkgOSTypechk:~0,4%" == "3777" (set "OSsubdir=%tempdriveLTR%\%tempsubdirName%")
goto :OSContinueCP

::------ END Telium 2 OS-SDK ---------------
:isOSfolderT3
::------ Telium 3 SDK pkg ---------------
if "%pkgOSTypechk:~0,10%" == "9990000000" (set "OSsubdir=%tempdriveLTR%\%tempsubdirName%")
::------ END Telium 3 SDK pkg ---------------
:OSContinueCP
if NOT "%OSsubdir%" == "" (
goto :ContinueCP
)
goto :eof

:FileCopy
Set "FileCopied=1"
set "OSsubdir="
set "MGRdir="
set "OSCATfileName="
set "MGRCATfileName="
set "pkgMEMname="
set "MEMsubdir="
set "DisaMemDLL=0"
set "MEMData=0"
set "MEMSizeCATfileName=%LLTTempPath%\%LLTTempSubP%\TEMPPKG\LoadMemSizing.Mxx"
cls
echo.
echo.
echo.* Creating Temporary download package, please wait ...
echo.%date%-%time%: Factory Download Package is selected >>"%ALLUSERSPROFILE%\LLTTemp\log\download.log"

if "%TeliumTYPE%" == "3" (goto :chkmainCatTelium3)
if EXIST "%Comppath%\%pkgDLType%\OS" ( 
	FOR /R "%Comppath%\%pkgDLType%\OS" %%G IN (3777*.?GN) DO (
	set "pkgOSTypechk=%%~nxG"
	set "tempsubdirName=%%~pG"
	set "tempdriveLTR=%%~dG"
	call :isOSfolder
	)
) ELSE (
	if EXIST "%Comppath%\%pkgDLType%" ( 
		FOR /R "%Comppath%\%pkgDLType%" %%G IN (3777*.?GN) DO (
		set "pkgOSTypechk=%%~nxG"
		set "tempsubdirName=%%~pG"
		set "tempdriveLTR=%%~dG"
		call :isOSfolder
		)
	)
)
goto :chkmainCat

:chkmainCatTelium3
if /I EXIST "%Comppath%\%pkgDLType%\PACKAGE" (
	FOR /R "%Comppath%\%pkgDLType%\PACKAGE" %%G IN (9990000000*.P3P) DO (
	set "pkgOSTypechk=%%~nxG"
	set "tempsubdirName=%%~pG"
	set "tempdriveLTR=%%~dG"
	call :isOSfolder
	)
) ELSE (
	if EXIST "%Comppath%\%pkgDLType%" ( 
		FOR /R "%Comppath%\%pkgDLType%" %%G IN (9990000000*.P3P) DO (
		set "pkgOSTypechk=%%~nxG"
		set "tempsubdirName=%%~pG"
		set "tempdriveLTR=%%~dG"
		call :isOSfolder
		)
	)
)
goto :chkmainCat

:chkmainCat
FOR /f "delims=" %%G IN ('dir "%Comppath%\%pkgDLType%\*.M??" /b/s/a-d') DO (
Set "chkExt=%%~xG"
call :CHKpkgTP
)
goto :DoneChkpkgTP

:ContinueCP
FOR /R "%OSsubdir%" %%G IN (*.M??) DO (
set "OSCATfileName=%%G"
Set "chkExt=%%~xG"
call :CHKpkgTP
)
goto :DoneChkpkgTP

:chkManager
if EXIST "%Comppath%\%pkgDLType%\Manager" ( 
	FOR /R "%Comppath%\%pkgDLType%\Manager" %%G IN (4778*.?GN) DO (
	set "pkgmgrname=%%~nxG"
	set "tempsubdirName=%%~pG"
	set "tempdriveLTR=%%~dG"
	call :isMGRfolder
	)
) ELSE (
	if EXIST "%Comppath%\%pkgDLType%" ( 
		FOR /R "%Comppath%\%pkgDLType%" %%G IN (4778*.?GN) DO (
		set "pkgmgrname=%%~nxG"
		set "tempsubdirName=%%~pG"
		set "tempdriveLTR=%%~dG"
		call :isMGRfolder
		)
	)
)
goto :eof

:isMGRfolder
if "%tempsubdirName:~0,1%" == "\" (set "tempsubdirName=%tempsubdirName:~1%")
if "%tempsubdirName:~-1%" == "\" (set "tempsubdirName=%tempsubdirName:~0,-1%")
if NOT "%MGRdir%" == "" (goto :eof)
if "%pkgmgrname:~0,4%" == "4778" (
set "MGRdir=%tempdriveLTR%\%tempsubdirName%"
	FOR /R "%tempdriveLTR%\%tempsubdirName%" %%G IN (*.M??) DO (
	set "MGRCATfileName=%%G"
	)
)
goto :eof

:DoneChkpkgTP
call :ProfileCHK

if "%TeliumTYPE%" == "2" (
	if EXIST "%Comppath%\%pkgDLType%" ( 
		FOR /R "%Comppath%\%pkgDLType%" %%G IN (%MEMAPIDT2%*.?GN) DO (
			if EXIST "%%G" (
			set "pkgMEMname=%%~nxG"
			set "tempsubdirName=%%~pG"
			set "tempdriveLTR=%%~dG"
			)
		) 
		FOR /R "%Comppath%\%pkgDLType%" %%G IN (MEMORY.CFG) DO (
			if EXIST "%%G" (
			set "MEMData=1"
			)
		) 
	)
goto :MemCHKpkgtpDone
)

::-------------In case Tetra has mem resize app ---------------
if "%TeliumTYPE%" == "3" (
	if EXIST "%Comppath%\%pkgDLType%" ( 
		FOR /R "%Comppath%\%pkgDLType%" %%G IN (%MEMAPIDT3%*.P3?) DO (
			if EXIST "%%G" (
			set "pkgMEMname=%%~nxG"
			set "tempsubdirName=%%~pG"
			set "tempdriveLTR=%%~dG"
			)
		) 
		FOR /R "%Comppath%\%pkgDLType%" %%G IN (MEMORY.CFG) DO (
			if EXIST "%%G" (
			set "MEMData=1"
			)
		) 
	)
)

:MemCHKpkgtpDone
if "%pkgMEMname%" == "" (
set "dllMEMapp=0"
goto :skipMGRchk
)
if "%tempsubdirName%" == "" (
set "dllMEMapp=0"
goto :skipMGRchk
)

if "%tempsubdirName:~0,1%" == "\" (set "tempsubdirName=%tempsubdirName:~1%")
if "%tempsubdirName:~-1%" == "\" (set "tempsubdirName=%tempsubdirName:~0,-1%")

::------Telium2 chk OS/TM --------------------
if "%TeliumTYPE%" == "3" ( goto :T3chkSDKtype )
if NOT EXIST "%tempdriveLTR%\%tempsubdirName%\%pkgMEMname%" (goto :skipMGRchk)
set "MEMsubdir=%tempdriveLTR%%tempsubdirName%"

if NOT EXIST "%Comppath%\%pkgDLType%\Manager" ( goto :chkOSdirect )
if NOT EXIST "%Comppath%\%pkgDLType%" ( goto :chkOSdirect )
call :chkManager

:chkOSdirect
if "X%OSCATfileName%" == "X" (
goto :chkMGRdirect
)
echo.;------ GROUPE Components ------>"%MEMSizeCATfileName%"
echo.;------ OS ------ >>"%MEMSizeCATfileName%"
for /f "tokens=* delims=" %%G IN ('type "%OSCATfileName%"') DO (
echo.%%G>>"%MEMSizeCATfileName%"
)
echo.;>>"%MEMSizeCATfileName%"

:chkMGRdirect
if "X%MGRCATfileName%" == "X" (
goto :chkPROFILEdirect
)
echo.;------ Manager ------ >>"%MEMSizeCATfileName%"
for /f "tokens=* delims=" %%G IN ('type "%MGRCATfileName%"') DO (
echo.%%G>>"%MEMSizeCATfileName%"
)
echo.;>>"%MEMSizeCATfileName%"

:chkPROFILEdirect
if NOT EXIST "%LLTTempPath%\%LLTTempSubP%\TEMPPKG\Load_profile.Mxx" ( goto :chkNARdirect )
echo.;------ Key File ------ >>"%MEMSizeCATfileName%"
if EXIST "%LLTTempPath%\%LLTTempSubP%\TEMPPKG\Load_profile.Mxx" (
	for /f "tokens=* delims=" %%G IN ('type "%LLTTempPath%\%LLTTempSubP%\TEMPPKG\Load_profile.Mxx"') DO (
	echo.%%G>>"%MEMSizeCATfileName%"
	)
)

:chkNARdirect

echo.;>>"%MEMSizeCATfileName%"
echo.;------ NAR COMPONENTS ------ >>"%MEMSizeCATfileName%"
echo.;------ Load Mem Sizing App ------ >>"%MEMSizeCATfileName%"
echo.%pkgMEMname%>>"%MEMSizeCATfileName%"
if "%MEMData%" == "1" (
echo.-e%datafolder%>>"%MEMSizeCATfileName%"
echo.MANAGER.PAR>>"%MEMSizeCATfileName%"
echo.MEMORY.CFG>>"%MEMSizeCATfileName%"
) ELSE (
echo.-e%datafolder%>>"%MEMSizeCATfileName%"
echo.MANAGER.PAR>>"%MEMSizeCATfileName%"
)
goto :skipMGRchk
::------END Telium2 chk OS/TM --------------------

:T3chkSDKtype
if NOT EXIST "%tempdriveLTR%\%tempsubdirName%\%pkgMEMname%" ( goto :skipMGRchk )
set "MEMsubdir=%tempdriveLTR%%tempsubdirName%"

if "X%OSCATfileName%" == "X" (
goto :T3chkProfiledirect
)
echo.;------ GROUPE Components ------>"%MEMSizeCATfileName%"
echo.;------ SDK ------ >>"%MEMSizeCATfileName%"
for /f "tokens=* delims=" %%G IN ('type "%OSCATfileName%"') DO (
echo.%%G>>"%MEMSizeCATfileName%"
)
echo.;>>"%MEMSizeCATfileName%"

:T3chkProfiledirect
if NOT EXIST "%LLTTempPath%\%LLTTempSubP%\TEMPPKG\Load_profile.Mxx" ( goto :T3chkNARdirect )
echo.;------ Profile ------ >>"%MEMSizeCATfileName%"
if EXIST "%LLTTempPath%\%LLTTempSubP%\TEMPPKG\Load_profile.Mxx" (
	for /f "tokens=* delims=" %%G IN ('type "%LLTTempPath%\%LLTTempSubP%\TEMPPKG\Load_profile.Mxx"') DO (
	echo.%%G>>"%MEMSizeCATfileName%"
	)
)

:T3chkNARdirect
echo.;>>"%MEMSizeCATfileName%"
echo.;------ NAR COMPONENTS ------ >>"%MEMSizeCATfileName%"
echo.;------ Load Mem Sizing App ------ >>"%MEMSizeCATfileName%"
echo.%pkgMEMname%>>"%MEMSizeCATfileName%"
if "%MEMData%" == "1" (
echo.-e%datafolder%>>"%MEMSizeCATfileName%"
echo.MEMORY.CFG>>"%MEMSizeCATfileName%"
) ELSE (
echo.-e%datafolder%>>"%MEMSizeCATfileName%"
echo.;>>"%MEMSizeCATfileName%"
)
goto :skipMGRchk

:skipMGRchk
call :copytotemp	
echo.%date%-%time%: Temporary package is created based on Factory Download Package >>"%ALLUSERSPROFILE%\LLTTemp\log\download.log"
if "%PKGtypeIndicator%" == "0" (
goto :Menu
) ELSE (
	if "%PKGtypeIndicator%" == "1" (
	goto :Menu
	)
	if "%PKGtypeIndicator%" == "3" (
	goto :Menu
	)
	if "%qaParam%" == "/IngPackager" (
		if NOT EXIST "%LLTTempPath%\%LLTTempSubP%\%TEMPPKGPATH%\" (MKDIR "%LLTTempPath%\%LLTTempSubP%\%TEMPPKGPATH%\" >Nul)
	xcopy /S /Q /Y "%LLTTempPath%\%LLTTempSubP%\TEMPPKG" "%LLTTempPath%\%LLTTempSubP%\%TEMPPKGPATH%" >Nul
	echo.
	echo.%Tline1% 
	echo.%Tline2%
	echo.                              %opt% Options 
	echo.--------------------------+---------------------------+---------------------------
	echo.
	echo. A temp package for ingPackager is created in a separate window.
	echo. The temparary package will be erased if press any key to continue ...
	start explorer "%LLTTempPath%\%LLTTempSubP%\%TEMPPKGPATH%\"
	pause
		if EXIST "%LLTTempPath%\%LLTTempSubP%\%TEMPPKGPATH%\" (DEL /S /Q "%LLTTempPath%\%LLTTempSubP%\%TEMPPKGPATH%\" >Nul)
	goto :CLEAR
	)
)
goto :NoPackage

:CHKpkgTP
set "chkExt=%chkExt:~0,3%"
set "chkExt=%chkExt:m=M%"

IF NOT "%TeliumTYPE%" == "2" (goto :T3chk)
if "%chkExt%" == ".M4" (
set "pkgType=2"
set "profileName=Public Key"
goto :Last
) ELSE (
	if "%chkExt%" == ".M5" (
	set "pkgType=2"
	set "profileName=Public Key"
	goto :Last
	) ELSE (
		if "%chkExt%" == ".M3" (
		set "pkgType=1"
		goto :Last
		) ELSE (
			if "%chkExt:~0,2%" == ".M" (
			set "pkgType=2"
			set "profileName=Public Key"
			goto :Last
			)
		)
	)
)
:T3chk
IF NOT "%TeliumTYPE%" == "3" (goto :Last)
set "pkgType=3"
set "profileName=ESSP"
goto :Last

:copytotemp
echo.%date%-%time%: Creating Temporary package For %PNUM% >>"%ALLUSERSPROFILE%\LLTTemp\log\download.log"
	FOR /R "%Comppath%\%pkgDLType%" %%G IN (*.*) DO (
		if NOT "%%nxG" == "Contents.lst" (
		COPY "%%G" /Y "%LLTTempPath%\%LLTTempSubP%\TEMPPKG\" > NUL
		)
	)
goto :Last

::------ Re-Enter COM port -------------

:ProfileCHK
set /a "MultiProfile=0"
set /a num=0
IF "%TeliumTYPE%" == "3" (goto :PROFchkT3)
FOR /R "%Comppath%\%pkgDLType%\PROFILE" %%H IN (*.kgn) DO (
Set "ProfName=%%H" 
set "chkExt=%%~xH"
set /a num+=1
call :CreateProfCat
)
goto :Last
:PROFchkT3
FOR /R "%Comppath%\%pkgDLType%\PROFILE" %%H IN (*.P3T) DO (
Set "ProfName=%%H" 
set "chkExt=%%~xH"
set /a num+=1
call :CreateProfCat
)
goto :Last

:CreateProfCat
if %num% equ 1 (
echo.;---- Profile: %profileName% File ---->"%LLTTempPath%\%LLTTempSubP%\TEMPPKG\Load_profile.Mxx"
dir /B "%ProfName%">>"%LLTTempPath%\%LLTTempSubP%\TEMPPKG\Load_profile.Mxx"
) 
set "MultiProfile=%num%"
goto :Last

:ReENTCOM
cls
echo.
echo.%Tline1% 
echo.%Tline2%
echo.
echo.                 Download Utility COM port selection 
echo.----------------+-----------------------------------------+-----------------------
IF %NBT% EQU 0 (
echo.    * Invalid: Only numbers are accepted *
echo.
set "NBT=1"
)
set "chkLines="
set "Option="
set "PORT="
if NOT ."%m%". == ."0". (
echo. * The COM port you entered ^(COM%NB%^) currently is not accessable. 
echo. * Please choose a different COM port
echo.
)
set /P PORT="* Enter COM port number, "X" = Exit, "I" = Ignore or [ENTER] for COM%NB%: "
if ."%PORT%". == ."". ( 
set "PORT=%NB%"
)

echo.PORT#%PORT%#>"%LLTTempPath%\%LLTTempSubP%\recomPort.txt"
if "%PORT%" == "x" ( set "PORT=X" )
if "%PORT%" == "X" ( goto :Last )
if "%PORT%" == "i" ( set "PORT=I" )
if "%PORT%" == "I" ( 
goto :Last 
)

::Make sure user entered an integer 
SET /A "NBT=%PORT%*1"
IF NOT "%NBT%" == "0" (
set "NB=%PORT%"
set "m=0"
call :ReCOMCHK
call :reComenable
goto :Last
) ELSE (
set "m=0"
)
goto :ReENTCOM

:reComenable
	if ."%chkLines%". == ."1". (
		if EXIST "%LLTTempPath%\%LLTTempSubP%\recomtemp.txt" (Del /S /Q "%LLTTempPath%\%LLTTempSubP%\recomtemp.txt" >nul )
		mode COM%NB%>"%LLTTempPath%\%LLTTempSubP%\recomtemp.txt"
			FOR /F "tokens=1,2,3 usebackq delims=:" %%x in ("%LLTTempPath%\%LLTTempSubP%\recomtemp.txt") do (
				if NOT ."%%y". == ."". (
				set "strTrimx=%%x"
				set "strTrimy=%%y"
				call :matchStr
				)
			)
			set "STATUSin="
			call :setstatus
			FOR /F "tokens=1,2 usebackq delims=#" %%y IN ("%LLTTempPath%\%LLTTempSubP%\Status.txt") DO (
				if ."%%y". == ."NB". (
				set "NB=%%z"
				)
				if ."%%y". == ."Status". (
				set "COMSTATUS=%%z"
				)
			)
			goto :Last
	) ELSE (
	if EXIST "%LLTTempPath%\%LLTTempSubP%\comtemp.txt" (Del "%LLTTempPath%\%LLTTempSubP%\comtemp.txt" >Nul)
	if EXIST "%LLTTempPath%\%LLTTempSubP%\recomtemp.txt" (Del "%LLTTempPath%\%LLTTempSubP%\recomtemp.txt" >Nul)
	if EXIST "%LLTTempPath%\%LLTTempSubP%\Status.txt" (Del "%LLTTempPath%\%LLTTempSubP%\Status.txt" >Nul)
	set "m=1"
	Set "chkLines=0"
	goto :ReENTCOM
	)
goto :Last

:ReCOMCHK
mode COM%NB%:115200 >nul
Set "chkLines=0"
if EXIST "%LLTTempPath%\%LLTTempSubP%\comtemp.txt" (Del /S /Q "%LLTTempPath%\%LLTTempSubP%\comtemp.txt" >nul )
mode COM%NB%|find "Baud" >"%LLTTempPath%\%LLTTempSubP%\comtemp.txt"
For /F %%A in ('FindStr "Baud" "%LLTTempPath%\%LLTTempSubP%\comtemp.txt"') do (
Set "chkLines=1"
) 
goto :Last

:matchStr
call :trimLeftx
call :trimLefty
if ."%strTrimx%". == ."Baud". (
set "comstrbaud=%strTrimx%"
set "comstrRate=%strTrimy%"
)
if ."%strTrimx%". == ."Parity". (
set "comstrPar=%strTrimx%"
set "comstrParVal=%strTrimy%"
)
if ."%strTrimx%". == ."Data Bits". (
set "comstrBits=%strTrimx%"
set "comstrBitsVal=%strTrimy%"
)
if ."%strTrimx%". == ."Stop Bits". (
set "comstrStop=%strTrimx%"
set "comstrStopVal=%strTrimy%"
)
goto :Last

:catName
for /f "tokens=1 delims=^." %%v in ("%perlc%") do (
	if %profStatus% == 1 (
		if "%perln%" == "" (
		set "Cname=%%v_withProfile"
		) ELSE (
		set "Cname=%%v_withProfile_with-%perln%"
		)
	) ELSE (
		if "%perln%" == "" (
		set "Cname=%%v"
		) ELSE (
		set "Cname=%%v_with-%perln%"
		)
	)
)
goto :Last

:USBPKGCreate
set "doneUSBcp=0"
if NOT EXIST "%LLTTempPath%\%LLTTempSubP%\%TEMPPKGPATH%\" (MKDIR "%LLTTempPath%\%LLTTempSubP%\%TEMPPKGPATH%\">Nul)
if NOT EXIST "%LLTTempPath%\%LLTTempSubP%\%TEMPPKGPATH%\%pkgDLType%" (MKDIR "%LLTTempPath%\%LLTTempSubP%\%TEMPPKGPATH%\%pkgDLType%">Nul)
if NOT EXIST "%LLTTempPath%\%LLTTempSubP%\%TEMPPKGPATH%\%pkgDLType%\%Cname%" (MKDIR "%LLTTempPath%\%LLTTempSubP%\%TEMPPKGPATH%\%pkgDLType%\%Cname%">Nul)
if EXIST "%LLTTempPath%\%LLTTempSubP%\%TEMPPKGPATH%\%pkgDLType%\%Cname%\%perlj%" (Del /S /Q "%LLTTempPath%\%LLTTempSubP%\%TEMPPKGPATH%\%pkgDLType%\%Cname%\%perlj%" >Nul)
FOR /F "eol=; tokens=* usebackq delims=#" %%c in ("%LLTTempPath%\%LLTTempSubP%\TEMPPKG\%perlj%") do (
set "pertc=%%c"
set "Filename=%%~nc"
call :DOUSBcreate
)
set "reDllmenu=2"
goto :Last

:DOUSBcreate
if /I "%Filename%" == "-epackage" ( set "paramschk=0" & goto :SkipeData )
if /I "%Filename%" == "-eswap" ( set "paramschk=0" & goto :SkipeData )
if /I "%Filename:~0,2%" == "-e" (
	if "%PKGtypeIndicator%" == "3" ( 
	echo.%pertc%>>"%LLTTempPath%\%LLTTempSubP%\%TEMPPKGPATH%\%pkgDLType%\%Cname%\%perlj%"
	)
set "paramschk=1"
goto :Last
) 

:SkipeData
if /I "%ExcludeComp%" == "0" (
goto :proceedDoUSB
)

if exist "%Comppath%\%pkgDLType%\%ExcludeComp%\%pertc%" (
goto :Last
) else (
	if exist "%Comppath%\%pkgDLType%\%ExcludeComp%\HOST\%pertc%" (	
	goto :Last
	) else (
		if exist "%Comppath%\%pkgDLType%\%ExcludeComp%\import\%pertc%" (	
		goto :Last
		) else (
			if exist "%Comppath%\%pkgDLType%\%ExcludeComp%\%datafolder%\%pertc%" (	
			goto :Last
			)
		)
	)
)
if /I "%ExcludeFiles%" == "0" (
goto :proceedDoUSB
)
:proceedDoUSB
if /I "%ExcludeFiles%" == "0" (
goto :DoUSBNoexlusion
)
FOR /F "eol=; tokens=1,2,3,4,5,* delims=#" %%a in ("%ExcludeFiles%") do (
	if /I "X%pertc%" == "X%%a" ( 
	goto :Last
	) else (
		if /I "X%pertc%" == "X%%b" ( 
		goto :Last
		) else (
			if /I "X%pertc%" == "X%%c" ( 
			goto :Last
			) else (
				if /I "X%pertc%" == "X%%d" ( 
				goto :Last
				) else (
					if /I "X%pertc%" == "X%%e" ( 
					goto :Last
					)
				)
			)
		)
	)
)
:DoUSBNoexlusion
if "%paramschk%" == "0" (	
	if EXIST "%LLTTempPath%\%LLTTempSubP%\TEMPPKG\%pertc%" (
	copy /Y "%LLTTempPath%\%LLTTempSubP%\TEMPPKG\%pertc%" "%LLTTempPath%\%LLTTempSubP%\%TEMPPKGPATH%\%pkgDLType%\%Cname%" >Nul
			if "%PKGtypeIndicator%" == "3" ( 
			echo.%pertc%>>"%LLTTempPath%\%LLTTempSubP%\%TEMPPKGPATH%\%pkgDLType%\%Cname%\%perlj%"
			)
	) ELSE (
		if /I "%Filename%" == "-epackage" ( 
			if "%PKGtypeIndicator%" == "3" ( 
			echo.%pertc%>>"%LLTTempPath%\%LLTTempSubP%\%TEMPPKGPATH%\%pkgDLType%\%Cname%\%perlj%"
			)
		) else (
			if /I "%Filename%" == "-eswap" ( 
				if "%PKGtypeIndicator%" == "3" ( 
				echo.%pertc%>>"%LLTTempPath%\%LLTTempSubP%\%TEMPPKGPATH%\%pkgDLType%\%Cname%\%perlj%"
				)
			) else (
			call :cpErrorCHK
			)
		
		)
	)	
) ELSE (
	if "%paramschk%" == "1" (
		if NOT EXIST "%LLTTempPath%\%LLTTempSubP%\%TEMPPKGPATH%\%pkgDLType%\%Cname%" (MKDIR "%LLTTempPath%\%LLTTempSubP%\%TEMPPKGPATH%\%pkgDLType%\%Cname%">Nul)
		if "%DDLSUBDIR%" == "2" (
			if NOT EXIST "%LLTTempPath%\%LLTTempSubP%\%TEMPPKGPATH%\%pkgDLType%\%Cname%\%datafolder%" (MKDIR "%LLTTempPath%\%LLTTempSubP%\%TEMPPKGPATH%\%pkgDLType%\%Cname%\%datafolder%">Nul)
		) else (
			if "%DDLSUBDIR%" == "1" (
				if NOT "%PKGtypeIndicator%" == "3" ( 
				if NOT EXIST "%LLTTempPath%\%LLTTempSubP%\%TEMPPKGPATH%\%pkgDLType%\%Cname%\%datafolder%" (MKDIR "%LLTTempPath%\%LLTTempSubP%\%TEMPPKGPATH%\%pkgDLType%\%Cname%\%datafolder%">Nul)
				)
			)
		)
		if EXIST "%LLTTempPath%\%LLTTempSubP%\TEMPPKG\%pertc%" (  
			if "%DDLSUBDIR%" == "2" (
			copy /Y "%LLTTempPath%\%LLTTempSubP%\TEMPPKG\%pertc%" "%LLTTempPath%\%LLTTempSubP%\%TEMPPKGPATH%\%pkgDLType%\%Cname%\%datafolder%\" >Nul
				if "%PKGtypeIndicator%" == "3" ( 
				echo..\%datafolder%\%pertc%>>"%LLTTempPath%\%LLTTempSubP%\%TEMPPKGPATH%\%pkgDLType%\%Cname%\%perlj%"
				)
			) else (
				if "%DDLSUBDIR%" == "1" (
					if "%PKGtypeIndicator%" == "3" ( 
					copy /Y "%LLTTempPath%\%LLTTempSubP%\TEMPPKG\%pertc%" "%LLTTempPath%\%LLTTempSubP%\%TEMPPKGPATH%\%pkgDLType%\%Cname%\" >Nul
					echo.%pertc%>>"%LLTTempPath%\%LLTTempSubP%\%TEMPPKGPATH%\%pkgDLType%\%Cname%\%perlj%"
					) else (
					copy /Y "%LLTTempPath%\%LLTTempSubP%\TEMPPKG\%pertc%" "%LLTTempPath%\%LLTTempSubP%\%TEMPPKGPATH%\%pkgDLType%\%Cname%\%datafolder%\" >Nul
					)
				) else (
				copy /Y "%LLTTempPath%\%LLTTempSubP%\TEMPPKG\%pertc%" "%LLTTempPath%\%LLTTempSubP%\%TEMPPKGPATH%\%pkgDLType%\%Cname%\" >Nul
					if "%PKGtypeIndicator%" == "3" ( 
					echo.%pertc%>>"%LLTTempPath%\%LLTTempSubP%\%TEMPPKGPATH%\%pkgDLType%\%Cname%\%perlj%"
					)
				)
			)
		) ELSE ( 
		call :cpErrorCHK
		)		
	)
)
goto :Last

:DelDataCatF
if /I "%Filename%" == "-epackage" ( set "paramschk=0" & goto :Last )
if /I "%Filename%" == "-eswap" ( set "paramschk=0" & goto :Last )
if /I "%Filename:~0,2%" == "-e" (
set "paramschk=1"
goto :Last
)

:SkipeData1
if "%paramschk%" == "1" (
call :CreateDelCat
)
goto :Last

:CreateDelCat
if EXIST "%LLTTempPath%\%LLTTempSubP%\TEMPPKG\%DelDataCatFile%" (
    FOR /F "eol=; tokens=* usebackq delims=#" %%g in ("%LLTTempPath%\%LLTTempSubP%\TEMPPKG\%DelDataCatFile%") do (
        if "%%g" == "%pertc%" (
        goto :Last
        )
    )
)
if "%paramschk%" == "1" (
	if NOT EXIST "%LLTTempPath%\%LLTTempSubP%\TEMPPKG\delDataF_%FNdelCat%.Mxx" (
	echo.;--- Delete Data files from %datafolder% drive --- >"%LLTTempPath%\%LLTTempSubP%\TEMPPKG\delDataF_%FNdelCat%.Mxx"
	echo.-e%datafolder%>>"%LLTTempPath%\%LLTTempSubP%\TEMPPKG\delDataF_%FNdelCat%.Mxx"
	)
	echo.%pertc%>>"%LLTTempPath%\%LLTTempSubP%\TEMPPKG\delDataF_%FNdelCat%.Mxx"
)
goto :Last

:cpErrorCHK
set /a "RETUSBerr+=1"
echo.%Cname%\%pertc%>>"%LLTTempPath%\%LLTTempSubP%\USBpkg_Failed.txt"
goto :Last

:setstatus
		Set "COMSTATUS=%comstrRate%^:%comstrBitsVal%^:%comstrParVal%^:%comstrStopVal%"
		set "NB=%NB%"
		echo.NB#%NB%#>"%LLTTempPath%\%LLTTempSubP%\status.txt"
		echo.Status#%COMSTATUS%#>>"%LLTTempPath%\%LLTTempSubP%\status.txt"
goto :Last

:trimLeftx
set "str=%strTrimx%"
for /f "tokens=* delims= " %%a in ("%str%") do set "str=%%a"
set "strTrimx=%str%"
goto :Last

:trimLefty
set "str=%strTrimy% a"
for /f "tokens=1,* delims= " %%a in ("%str%") do set "str=%%a"
set "strTrimy=%str%"
goto :Last

::------ Re-Enter COM port - END-------------
:Usage
echo.
echo.%Tline1% 
echo.%Tline2%
echo.
echo.Usage:	CMD.EXE window from .\script folder, type-in:
echo.
echo.	Download.bat /Switch /DLLopt /Path for output /ExcludeComp /excludeFiles
echo.
echo.	- For IngPackger temp package, /Switch = /IngPackager [IngPackager GUI]
echo.	- To create USB package, /Switch = /USB [No GUI]
echo.	- To create L package, /Switch = /LPKG [No GUI]
echo.	/DLLoption=1 [download opt], Only options supported in cfg
echo.	/Path for output [c:\temp used if not provided] 
echo.	/ExcludeComp = 0 - No exclusion (default), =KIA Exclude KIA folder
echo.	/excludeFiles [separated by #], e.g. /PARAMS.PAR#FILE2#...# [MAX 5 files]
echo.	Note: if /Switch not empty, then SilentMode=1 [No GUI displayed]
echo.
goto :Last

:: ----- Checking download status -------------------
:StatusCHK
set "ResultCHK="
set "RetcodeCHK="
if NOT EXIST "%LLTTempPath%\%LLTTempSubP%\TEMPPKG\Batchlog.txt" (
set "Result=unknown reason."
set "Retcode=999"
goto :eof
)
FOR /F "usebackq" %%i IN ("%LLTTempPath%\%LLTTempSubP%\TEMPPKG\Batchlog.txt") DO (
	if %%i LSS 888 (
	set "RetcodeCHK=%%i"
	echo. >>"%ALLUSERSPROFILE%\LLTTemp\log\download.log"
	echo.%date%-%time%: LLT utility download log >>"%ALLUSERSPROFILE%\LLTTemp\log\download.log"
	echo.------------------------------------------------------->>"%ALLUSERSPROFILE%\LLTTemp\log\download.log"
	Type "%LLTTempPath%\%LLTTempSubP%\TEMPPKG\Batchlog.txt" >>"%ALLUSERSPROFILE%\LLTTemp\log\download.log"
	echo.------------------------------------------------------->>"%ALLUSERSPROFILE%\LLTTemp\log\download.log"
	echo. >>"%ALLUSERSPROFILE%\LLTTemp\log\download.log"
	goto :eof
	)
)
goto :eof

:getInstPath
Set "LLTtempFileName=LLT.exe"
if EXIST "%LLTTempPath%\LocalLLTPath.txt" (Del /S /Q "%LLTTempPath%\LocalLLTPath.txt" >Nul)
For /F "tokens=2 delims==" %%a In ('wmic os get caption /value') Do ( 
set Curros=%%a
)

Set "RegQry=HKLM\Hardware\Description\System\CentralProcessor\0"
 
REG.exe Query %RegQry% > "%LLTTempPath%\checkOS.txt"
 
Find /i "x86" < "%LLTTempPath%\CheckOS.txt" > "%LLTTempPath%\StringCheck.txt"
 
If %ERRORLEVEL% == 0 (
    set regpath=HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\Windows\CurrentVersion\Uninstall
) ELSE (
    set regpath=HKEY_LOCAL_MACHINE\SOFTWARE\Wow6432Node\Microsoft\Windows\CurrentVersion\Uninstall
)
set "VALUE_NAME=InstallLocation"
set "Version_NAME=DisplayVersion"
set /a "menuInd=1"
for /f "tokens=*" %%i in ('reg query %regpath%^|find "LLT"') do (
	FOR /F "usebackq tokens=3*" %%v IN (`REG QUERY "%%i" /v %Version_NAME% 2^>nul`) DO (
	set "VersionLLT=%%v"
	)
	FOR /F "usebackq tokens=3*" %%A IN (`REG QUERY "%%i" /v %VALUE_NAME% 2^>nul`) DO (
		if NOT "%%A" == "" (
			if NOT "%%B" == "" (
		    		if EXIST "%%A %%B" (
					set "LLTtoolType=0"
		    		set "LocalLLTP=%%A %%B"
		    		call :addLLTLocalPath
		    		) 
		    	) else (
		    		if EXIST "%%A" (
					set "LLTtoolType=0"
		    		set "LocalLLTP=%%A"
		    		call :addLLTLocalPath
		    		) 
		    	)
		)
	)
)
:: check jLLT
:FindjLLT
set "progress=..."
echo. Please wait ...
echo.
echo. Checking LLT installation path
echo.---------------------------------

:FullFindjLLT
if EXIST "%LLTTempPath%\LocaljLLTinst.txt" (del /F "%LLTTempPath%\LocaljLLTinst.txt")
for /f "tokens=1,2,3,4,5,6,7,8,9,10,* delims=\ " %%a  in ('fsutil fsinfo drives') do (
	set "tempDriveLTE=%%a"
	if /I NOT "%%a" == "drives:" (
	call :chkDrives
	)
	set "tempDriveLTE=%%b"
	if /I NOT "%%b" == "drives:" (
	call :chkDrives
	)
	set "tempDriveLTE=%%c"
	if /I NOT "%%c" == "drives:" (
	call :chkDrives
	)
	set "tempDriveLTE=%%d"
	if /I NOT "%%d" == "drives:" (
	call :chkDrives
	)
	set "tempDriveLTE=%%e"
	if /I NOT "%%e" == "drives:" (
	call :chkDrives
	)
	set "tempDriveLTE=%%f"
	if /I NOT "%%f" == "drives:" (
	call :chkDrives
	)
	set "tempDriveLTE=%%g"
	if /I NOT "%%g" == "drives:" (
	call :chkDrives
	)
	set "tempDriveLTE=%%h"
	if /I NOT "%%h" == "drives:" (
	call :chkDrives
	)
	set "tempDriveLTE=%%i"
	if /I NOT "%%i" == "drives:" (
	call :chkDrives
	)
	set "tempDriveLTE=%%j"
	if /I NOT "%%j" == "drives:" (
	call :chkDrives
	)
)
:ENDFindjLLT
for /f "tokens=* delims=" %%a IN ('type "%LLTTempPath%\LocaljLLTinst.txt"') DO (
Set "LocalLLTP=%%~dpa"
Set "LLTtempFileName=%%~nxa"
call :getjLLTVer
)
goto :eof
::----------chkDrives-------------------------
:chkDrives
set "progress=%progress%..."

if "%tempDriveLTE%" == "" (goto :eof)
if NOT EXIST "%tempDriveLTE%\program*" (goto :eof)

FOR /F "tokens=1,2,3,* delims=/- " %%x in ('fsutil fsinfo drivetype %tempDriveLTE%') do (
	if /I "%%y" == "cd" (
		if /I "%%y" == "Remote" (
		goto :eof
		)
	)
)

cd /d "%tempDriveLTE%\"

if "%PartialChk%" == "0" (goto :chkDRFull)

FOR /f "delims=" %%G IN ('dir /AD /B "%tempDriveLTE%\program*"') DO (
	if EXIST "%%~dpnG" (
		if /I NOT "%%G" == "ProgramData" (
		echo. Checking %%~dpnG for installation path %progress%
		where /r "%%~dpnG" *LLT.exe>>"%LLTTempPath%\LocaljLLTinst.txt"
		)
	) 
)
goto :eof

:chkDRFull
FOR /F "tokens=1,2,3,* delims=/- " %%x in ('fsutil fsinfo drivetype %tempDriveLTE%') do (
echo. Checking %tempDriveLTE% drive %progress%
where /r "%%x" *LLT.exe>>"%LLTTempPath%\LocaljLLTinst.txt" 
echo.
)
goto :eof
::----------END chkDrives-------------------------

:getjLLTVer
if "%LocalLLTP:~-1%" == "\" (
set "LocalLLTP=%LocalLLTP:~0,-1%"
)

if NOT EXIST "%LocalLLTP%\configuration" (goto :eof)

Set "VersionLLT=%LocalLLTP:(=[%"
Set "VersionLLT=%VersionLLT:)=]%"

for /f "tokens=* delims=" %%a IN ('echo.%VersionLLT%') DO (
set "VersionLLT=%%~nxa"
)
if /I "%VersionLLT:~0,3%" == "LLT" (
set "VersionLLT=j%VersionLLT%"
set "LLTtoolType=1"
) ELSE (
	if /I "%VersionLLT:~0,4%" == "jLLT" (
	set "VersionLLT=%VersionLLT%"
	set "LLTtoolType=1"
	) ELSE (
	set "VersionLLT=jLLT%VersionLLT%"
	set "LLTtoolType=1"
	)
)

call :addLLTLocalPath
goto :eof

:addLLTLocalPath
if "%LocalLLTP:~-1%" == "\" (
set "LocalLLTP=%LocalLLTP:~0,-1%"
)
echo.0#%LocalLLTP%#%VersionLLT%#%menuInd%#%LLTtempFileName%#%LLTtoolType%#;>>"%LLTTempPath%\LocalLLTPath.txt"
set /a "menuInd+=1"
goto :eof

:Status
::if "%LLTtoolType%" == "1" (goto :Match)
set "Result="
set "Retcode="
if NOT EXIST "%LLTTempPath%\%LLTTempSubP%\TEMPPKG\Batchlog.txt" (goto :Unknown)
FOR /F "usebackq" %%i IN ("%LLTTempPath%\%LLTTempSubP%\TEMPPKG\Batchlog.txt") DO (
	if %%i LSS 888 (
	set "Retcode=%%i"
	echo. >>"%ALLUSERSPROFILE%\LLTTemp\log\download.log"
	echo.%date%-%time%: LLT utility download log >>"%ALLUSERSPROFILE%\LLTTemp\log\download.log"
	echo.------------------------------------------------------->>"%ALLUSERSPROFILE%\LLTTemp\log\download.log"
	Type "%LLTTempPath%\%LLTTempSubP%\TEMPPKG\Batchlog.txt" >>"%ALLUSERSPROFILE%\LLTTemp\log\download.log"
	echo.------------------------------------------------------->>"%ALLUSERSPROFILE%\LLTTemp\log\download.log"
	echo. >>"%ALLUSERSPROFILE%\LLTTemp\log\download.log"
	goto :Match
	)
)

:Match
if ."%Retcode%". == ."". (set "Retcode=999")
if ."%Retcode%". == ."0". (goto :Stat0)
if "%Retcode%" == "-1" (goto :Stat-1)
if "%Retcode%" == "-2" (goto :Stat-2)
if "%Retcode%" == "-3" (goto :Stat-3)
if "%Retcode%" == "-4" (goto :Stat-4)
if "%Retcode%" == "-5" (goto :Stat-5) 
if "%Retcode%" == "-6" (goto :Stat-6)
if "%Retcode%" == "-7" (goto :Stat-7)
if "%Retcode%" == "-8" (goto :Stat-8)
if "%Retcode%" == "-9" (goto :Stat-9)
if "%Retcode%" == "-10" (goto :Stat-10)
if "%Retcode%" == "-11" (goto :Stat-11)
if "%Retcode%" == "-12" (goto :Stat-12)
if "%Retcode%" == "-13" (goto :Stat-13)
if "%Retcode%" == "-14" (goto :Stat-14)
if "%Retcode%" == "-15" (goto :Stat-15) 
if "%Retcode%" == "-17" (goto :Stat-17)
if "%Retcode%" == "-18" (goto :Stat-18)
if "%Retcode%" == "-19" (goto :Stat-19)
if "%Retcode%" == "-20" (goto :Stat-20) 
if "%Retcode%" == "-21" (goto :Stat-21) 
if "%Retcode%" == "-22" (goto :Stat-22) 
if "%Retcode%" == "-23" (goto :Stat-23) 
if "%Retcode%" == "-24" (goto :Stat-24) 
if "%Retcode%" == "-25" (goto :Stat-25) 
if "%Retcode%" == "-99" (goto :Stat-99)  
goto :END

:Stat0
set "Result=OK"
goto :END

:Stat-1
set "Result=missing parameter"
goto :END

:Stat-2
set "Result=catalog file access problem"
goto :END

:Stat-3
set "Result=resulting file access problem"
goto :END

:Stat-4
set "Result=downloadable files access problem"
goto :END

:Stat-5
set "Result=LLT already running"
goto :END

:Stat-6
set "Result=LLT configuring file missing (LLT.INI, LLT.LNG, LLT.PRM)"
goto :END

:Stat-7
set "Result=connection name ("LLT Connection") not found in Windows RAS"
goto :END

:Stat-8
set "Result=PPP connection problem"
goto :END

:Stat-9
set "Result=FTP connection problem"
goto :END

:Stat-10
set "Result=FTP error during file transfer"
goto :END

:Stat-11
set "Result=terminal not responding once PPP connection has been established"
goto :END

:Stat-12
set "Result=LLT cannot be run on such Windows platform"
goto :END

:Stat-13
set "Result=LLT identification not recognized by the terminal"
goto :END

:Stat-14
set "Result=unauthorized activity"
goto :END

:Stat-15
set "Result=activity badly finished, one reason could be profile issue"
goto :END

:Stat-17
set "Result=can not download a file a diagnostic activity"
goto :END

:Stat-18
set "Result=can not found the RAS phonebook"
goto :END

:Stat-19
set "Result=COM port unknown"
goto :END

:Stat-20
set "Result=Catalogue file not adapted for this terminal"
goto :END

:Stat-21
set "Result=File not intended for this Telium range"
goto :END

:Stat-22
set "Result=An error occurs during download"
goto :END

:Stat-23
set "Result=An error occurs during upload"
goto :END

:Stat-24
set "Result=The destination on the terminal is unreachable"
goto :END

:Stat-25
set "Result=Cannot access to this terminal file"
goto :END

:Stat-99
set "Result=Unexpected error"
goto :END

:Unknown
if NOT EXIST "%LLT%" (
set "Result=Cannot find LLT Tool."
) ELSE (
set "Result=unknown reason."
)
set "Retcode=999"
goto :END

:CaseConvert -- converts lowercase characters to UPPER CASE
for %%a in ("a=A" "b=B" "c=C" "d=D" "e=E" "f=F" "g=G" "h=H" "i=I"
            "j=J" "k=K" "l=L" "m=M" "n=N" "o=O" "p=P" "q=Q" "r=R"
            "s=S" "t=T" "u=U" "v=V" "w=W" "x=X" "y=Y" "z=Z") do (
	call set chkExt=%%chkExt:%%~a%%%
)
goto :Last

:CaseConvertUL -- converts UPPER CASE characters to lowercase
for %%a in ("A=a" "B=b" "C=c" "D=d" "E=e" "F=f" "G=g" "H=h" "I=i"
            "J=j" "K=k" "L=l" "M=m" "N=n" "O=o" "P=p" "Q=q" "R=r"
            "S=s" "T=t" "U=u" "V=v" "W=w" "X=x" "Y=y" "Z=z") do (
	call set Filename=%%Filename:%%~a%%%
)
goto :Last

:Exit
call :StoreParam
echo.
echo.
set /p T=* Press Enter Key to quit download ...
echo.%date%-%time%: Download process is terminated by user >>"%ALLUSERSPROFILE%\LLTTemp\log\download.log"
goto :CLEAR

:InstLocal
cls
echo.
Echo.%Tline1% 
echo.%Tline2%
echo.
echo.* Temp folder locked, or you are NOT running script on your local, 
echo.* Check your LLTtemp folder. 
echo.* See install.txt for reference.
echo.
echo.%Tline3%
echo.
echo.%date%-%time%: Package directory is not writable or does not exist >>"%ALLUSERSPROFILE%\LLTTemp\log\download.log"
set /p T=* Press Enter Key to quit download ...
goto :CLEAR

:NoPackage
cls
echo.
Echo.%Tline1% 
echo.%Tline2%
echo.
echo.* Could not find package. 
echo.* Please make sure your package is installed properly. 
echo.* See install.txt for reference.
echo.
echo.%date%-%time%: Could not find package, maybe directory structure is incorrect >>"%ALLUSERSPROFILE%\LLTTemp\log\download.log"
echo.%Tline3%
echo.
set /p T=* Press Enter Key to quit download ...
goto :CLEAR

:END
set "reDllmenu=1"
goto :RESMenu

:REDLLNOW
COLOR 17
echo.
echo.
::======
if NOT ."%Retcode%". == ."0". (goto :NOK)
echo.	##############################################################
echo. 	                                                           
if "%profStatus%" EQU "1" (
echo. 	 1. Profile - %profileName% File is loaded successfully.           
echo. 	                                                           
echo. 	 2. Download on COM%NB% is finished successfully.            
) ELSE ( 
echo. 	 1. Download on COM%NB% is finished successfully.            
)
echo. 	    ^(%perlk%^)
echo. 	
echo. 	    Please Wait Until Terminal Rebooted ...                
echo. 	                                                           
echo.	##############################################################
echo.
echo.%date%-%time%: Download on COM%NB% is finished successfully (Return Code: %Retcode%, error Code: %errcode%, error Desc: %errDescription% ) >>"%ALLUSERSPROFILE%\LLTTemp\log\download.log"
goto :Last

:strlen <resultVar> <stringVar>
(   
    setlocal EnableDelayedExpansion
    set "s=!%~2!#"
    set "len=0"
    for %%P in (4096 2048 1024 512 256 128 64 32 16 8 4 2 1) do (
        if "!s:~%%P,1!" NEQ "" ( 
            set /a "len+=%%P"
            set "s=!s:~%%P!"
        )
    )
)
( 
    endlocal
    set "%~1=%len%"
    exit /b
)
goto :Last

:REDLLUSB
call :strlen result pkgDLType

COLOR 17
echo.     
if "%doneUSBcp%" == "1" (
echo. 	  The %TEMPPKGDISPNM% temporary package has been copied to "%orginUSBdr%%pkgDLType%"               
) ELSE (
    if EXIST "%LLTTempPath%\%LLTTempSubP%\%TEMPPKGPATH%\%pkgDLType%" (
        if "%RETUSBerr%" == "0" (
        echo. 	  The %TEMPPKGDISPNM% temporary package is created successfully
        ) ELSE (
        echo. 	  %TEMPPKGDISPNM% temporary package created with error ...
        )
    ) ELSE (
    echo. 	  The %TEMPPKGDISPNM% temporary package is not created yet                           
    )
)
echo.     
echo.
if NOT ."%RETUSBerr%". == ."0". ( call :NOKUSB ) 
if "%profStatus%" EQU "1" (
	if NOT "%pkgType%" == "1" (
	set "tempprofStatus=1"
	)
)
if EXIST "%LLTTempPath%\%LLTTempSubP%\%TEMPPKGPATH%\%pkgDLType%" (                                                    
	if "%tempprofStatus%" EQU "1" (
	echo. 	   1. Profile - %profileName% File is included in the %TEMPPKGDISPNM% DLL package
	echo. 	                                                             
	echo. 	   2. %TEMPPKGDISPNM% Download Temporary Package is created.  
	) ELSE (
	echo. 	   1. %TEMPPKGDISPNM% Download Temporary Package is created.  
	)
	echo. 
	dir /AD /B "%LLTTempPath%\%LLTTempSubP%\%TEMPPKGPATH%\%pkgDLType%" >"%LLTTempPath%\%LLTTempSubP%\USBpkgStat.txt"
	echo. 	      Following has been added to %TEMPPKGDISPNM% temporary package:
	echo. 	      ------------------------------------------
	for /f "tokens=* usebackq delims=#" %%x in ("%LLTTempPath%\%LLTTempSubP%\USBpkgStat.txt") do (
	echo. 	      - %%x
	)
) ELSE (
echo. 	    %TEMPPKGDISPNM% Download Temporary Package Is Empty.  
)
echo.
:: ---- check spaces needed -----
set /a "numSpace=9-%result%"
set "SpaceDisp="
:chkNumSpace
if %numSpace% EQU 0 goto :doneNumSpace
set "SpaceDisp=%SpaceDisp% "
set /a "numSpace=%numSpace%-1"
goto :chkNumSpace

:doneNumSpace
:: ---- END check spaces needed -----
if EXIST "%LLTTempPath%\%LLTTempSubP%\%TEMPPKGPATH%\%pkgDLType%" ( 
	if "%qaParam%" == "/USB" (
	echo. 	    ͻ  
	echo. 	       Tips for Manully copy the %TEMPPKGDISPNM% temp package      
	echo. 	        ----------------------------------------       
	echo. 	      - Press "O" to open the %TEMPPKGDISPNM% temporary package     
	echo. 	      - Copy the "%pkgDLType%" folder to %TEMPPKGDISPNM% drive ^(root^)%SpaceDisp%  
	echo. 	      - Then start %TEMPPKGDISPNM% Download on Terminal.           
	echo. 	    ͼ
	echo. 
	)
) 
echo.%date%-%time%: %TEMPPKGDISPNM% download temp package is created (Return Code: %RETUSBerr%) >>"%ALLUSERSPROFILE%\LLTTemp\log\download.log"
goto :Last

:NOKUSB
COLOR 47
echo.     ********************************************************************
echo.     * %TEMPPKGDISPNM% temporary package is NOT created properly due to:            *
echo.     * -----------------------------------------------------------------*
echo.     * %RETUSBerr% file^(s^) can not be copied to destination below:
echo.     *                                                                  *
if EXIST "%LLTTempPath%\%LLTTempSubP%\USBpkg_Failed.txt" (
	FOR /F "eol=; tokens=* usebackq delims=#" %%z in ("%LLTTempPath%\%LLTTempSubP%\USBpkg_Failed.txt") do (
	echo.     *    %%z
	)
) ELSE (
echo.         Do not know which file could not be copied.
)
echo.     *                                                                  * 
echo.     ******************************************************************** 
echo.
echo.%date%-%time%: %TEMPPKGDISPNM% download temp package is NOT created properly(Return Code: %RETUSBerr%) >>"%ALLUSERSPROFILE%\LLTTemp\log\download.log"
echo.
goto :Last

:NOK
COLOR 47
@echo.     -----------------------------------------------------------------
@echo.         ******    **      *******    *         ********  ******
@echo.         *        *  *        *       *         *         *     *
@echo.         *       *    *       *       *         *         *      *
@echo.         *****  ********      *       *         *****     *      *
@echo.         *      *      *      *       *         *         *      *
@echo.         *      *      *      *       *         *         *     *
@echo.         *      *      *   *******    *******   ********  ******
@echo.     -----------------------------------------------------------------
@echo.           DOWNLOAD ERROR, RELOAD CURRENT UNIT IS REQUIRED.
echo.
echo.* Download on COM%NB% failed due to: 
echo.  -----------------------------------
if ."%Retcode%". == ."999". (
set "Retcode=N/A"
)
echo.  - %Result% (Return Code: %Retcode%)
if "%LLTtoolType%" == "1" (
echo.    [Error Code: %errcode%, Error Description: %errDescription%]
)
echo.
echo.%date%-%time%: Download on COM%NB% failed due to "%Result% (Return Code: %Retcode%, error Code: %errcode%, error Desc: %errDescription%)" >>"%ALLUSERSPROFILE%\LLTTemp\log\download.log"
goto :Last

:CLEAR
if "%SilentMode%" == "1" ( 
	if exist "%outputFolder%\%LLTTempSubP%\%TEMPPKGPATH%" ( 
	RMDIR /S /Q "%outputFolder%\%LLTTempSubP%\%TEMPPKGPATH%" >Nul 
	)
	if EXIST "%LLTTempPath%\%LLTTempSubP%\%TEMPPKGPATH%" (
	xcopy /R /Q /S /Y "%LLTTempPath%\%LLTTempSubP%\%TEMPPKGPATH%" "%outputFolder%\%LLTTempSubP%\%TEMPPKGPATH%\" >Nul
	)
)
set "Result="
set "Retcode="
if EXIST "%LLTTempPath%\%LLTTempSubP%\TEMPPKG" ( RMDIR /S /Q "%LLTTempPath%\%LLTTempSubP%\TEMPPKG" >Nul)
if "%PKGtypeIndicator%" == "1" (
	if EXIST "%LLTTempPath%\%LLTTempSubP%\%TEMPPKGPATH%" ( RMDIR /S /Q "%LLTTempPath%\%LLTTempSubP%\%TEMPPKGPATH%" >Nul )
)
if "%PKGtypeIndicator%" == "3" (
if EXIST "%LLTTempPath%\%LLTTempSubP%\%TEMPPKGPATH%" ( RMDIR /S /Q "%LLTTempPath%\%LLTTempSubP%\%TEMPPKGPATH%" >Nul )
)
if "%qaParam%" == "/IngPackager" (
	if EXIST "%LLTTempPath%\%LLTTempSubP%\%TEMPPKGPATH%" ( RMDIR /S /Q "%LLTTempPath%\%LLTTempSubP%\%TEMPPKGPATH%" >Nul )
)
if EXIST "%LLTTempPath%\%LLTTempSubP%\comtemp.txt" ( Del /S /Q "%LLTTempPath%\%LLTTempSubP%\comtemp.txt" >Nul )
if EXIST "%LLTTempPath%\%LLTTempSubP%\recomtemp.txt" ( Del /S /Q "%LLTTempPath%\%LLTTempSubP%\recomtemp.txt" >Nul )
if EXIST "%LLTTempPath%\%LLTTempSubP%\numcomtemp.txt" ( Del /S /Q "%LLTTempPath%\%LLTTempSubP%\numcomtemp.txt" >Nul )
if EXIST "%LLTTempPath%\%LLTTempSubP%\status.txt" ( Del /S /Q "%LLTTempPath%\%LLTTempSubP%\status.txt" >Nul )
if EXIST "%LLTTempPath%\%LLTTempSubP%\recomPort.txt" ( Del /S /Q "%LLTTempPath%\%LLTTempSubP%\recomPort.txt" >Nul )
if EXIST "%LLTTempPath%\%LLTTempSubP%\USBpkg_Failed.txt" ( Del /S /Q "%LLTTempPath%\%LLTTempSubP%\USBpkg_Failed.txt" >Nul )
if EXIST "%LLTTempPath%\%LLTTempSubP%\USBpkgStat.txt" ( Del /S /Q "%LLTTempPath%\%LLTTempSubP%\USBpkgStat.txt" >Nul )
if EXIST "%LLTTempPath%\%LLTTempSubP%\USBdrletter.txt" ( Del /S /Q "%LLTTempPath%\%LLTTempSubP%\USBdrletter.txt">Nul )
if NOT "%LLTTempSubP%" == "" (
	if EXIST "%LLTTempPath%\%LLTTempSubP%" ( RMDIR /S /Q "%LLTTempPath%\%LLTTempSubP%" >Nul )
)
echo. >>"%ALLUSERSPROFILE%\LLTTemp\log\download.log"
echo.
echo. ---------- Download Script Ended ----------
echo.
echo.          *********          *********          *********>>"%ALLUSERSPROFILE%\LLTTemp\log\download.log"
echo. >>"%ALLUSERSPROFILE%\LLTTemp\log\download.log"
echo.%date%-%time%: ---------- Script Ended ---------- >>"%ALLUSERSPROFILE%\LLTTemp\log\download.log"
echo.================================================================>>"%ALLUSERSPROFILE%\LLTTemp\log\download.log"
Exit
:Last